# Definition der Maplets fuer die Aufgabenumgebung "Technische Mechanik I"
# ========================================================================

with(Maplets):with(Maplets[Elements]):

Digits:=5:

# globale Variable fuer den Pfad des Acrobat-Readers
__acropfad:="\"C:\\Programme\\Adobe\\Acrobat 5.0\\Reader\\AcroRd32.exe\" ";


#--- Einlesen der Dateien mit den korrekten Loesungen und den Checkprozeduren

#read "korrekt_TM1Blatt1.mpl":
#read "korrekt_TM1Blatt2.mpl":
#read "korrekt_TM1Blatt3.mpl":
#read "korrekt_TM1Blatt4.mpl":
read "korrekt_TM1.mpl":

read "checkprozeduren.mpl":
read "tool_prozeduren.mpl":
#read "Maplets_Blatt1.mpl":
#read "Maplets_Blatt2.mpl":
#read "Maplets_Blatt3.mpl":
#read "Maplets_Blatt4.mpl":
read "map1test.mpl":


###################################################################################

# Start der Benutzeroberflaeche und Verzweigung in Aufgabenfenster

Auswahl := proc()

global __aufgabe:  
local aufgabe, aufgabenstring, blatt, aufgabenmaplet;  

aufgabenstring:=convert(Maplets:-Tools:-Get('CoB1'),list);

blatt:=op(7,aufgabenstring);
if nops(aufgabenstring)=18 then aufgabe:=op(18,aufgabenstring); else
	aufgabe:=cat(op(18,aufgabenstring),op(19,aufgabenstring)); fi;

__aufgabe:="TM1B"||blatt||"A"||aufgabe;
aufgabenmaplet:=maplet_||__aufgabe;
Maplets[Display](aufgabenmaplet);

end proc:

####################################################################################


start_maplet:= Maplet(
			Window('title'="Technische Mechanik I",
				[BoxRow('border'=true,[
					[Label("Aufgabenumgebung", 'font' = Font("times", bold, 24))],
					[Label("fr Technische", 'font' = Font("times", bold, 24))],
					[Label("Mechanik I", 'font' = Font("times", bold, 24))]]),   
                                                                                           
				BoxRow('border'=false,(
					["Whlen Sie eine Aufgabe aus:"],  
					[ComboBox['CoB1']("Blatt 1, Aufgabe 1", sort([
						"Blatt 1, Aufgabe 1", 
						"Blatt 1, Aufgabe 2", 
						"Blatt 1, Aufgabe 3", 
						"Blatt 1, Aufgabe 4",                         
						"Blatt 1, Aufgabe 5",
						"Blatt 1, Aufgabe 6", 
						"Blatt 2, Aufgabe 1", 
						"Blatt 2, Aufgabe 2",
						"Blatt 2, Aufgabe 3",
						"Blatt 2, Aufgabe 4",
						"Blatt 2, Aufgabe 5",
						"Blatt 2, Aufgabe 6",
						"Blatt 2, Aufgabe 7",
						"Blatt 3, Aufgabe 1",
						"Blatt 3, Aufgabe 2",
						"Blatt 3, Aufgabe 3",
						"Blatt 3, Aufgabe 4",
						"Blatt 3, Aufgabe 5",
						"Blatt 3, Aufgabe 6",
						"Blatt 3, Aufgabe 7",
						"Blatt 3, Aufgabe 8a",
						"Blatt 3, Aufgabe 8b",
						"Blatt 3, Aufgabe 9",
						"Blatt 4, Aufgabe 1",
						"Blatt 4, Aufgabe 2",
						"Blatt 4, Aufgabe 3",
						"Blatt 4, Aufgabe 4",
						"Blatt 4, Aufgabe 5",
						"Blatt 4, Aufgabe 6",
						"Blatt 4, Aufgabe 7",
						"Blatt 4, Aufgabe 8"], 
					lexorder))
					]))   ,
				BoxRow('border'=false,(
					 [["Oder starten Sie eines der folgenden Tools:"],  
					 [Button("Seileck/Krafteck-Plot", Evaluate(function='Maplets[Display](seileck_maplet)')), 
					  Button("Culmann-Plot", Evaluate(function='Maplets[Display](culmann_maplet)')), 
					  Button("Querschnittswerte", Evaluate(function='Maplets[Display](querschnitt_maplet)')), 
					  Button("Foeppl-Plot", Evaluate(function='Maplets[Display](foeppl_plot_maplet)'))]
					 ])
				      ),
         
				[Button("OK", Evaluate(function="Auswahl")), Button("Ende", Shutdown())]
			])):



####################################################################################



####################################################################################

FehlermapletGleichung:= Maplet(BoxRow([

	[Label("Die Gleichung ist nicht korrekt!",'halign'=right, 'font' = Font("arial", bold, italic, 14))],
        [TextField['Artwert'](value="1", visible=false), TextField['Ausdruckwert'](value="2", visible=false)],                                                                                                                                                                    
	[Button("OK", Shutdown()),Button("Hinweis: Fehlerart",
			Evaluate(function="fehlerhinweis_gleichung",Argument('Artwert'))),
	Button("Hinweis: Fehlerhafter Ausdruck", 
			Evaluate(function="fehlerhinweis_gleichung",Argument('Ausdruckwert'))),
	Button("Zeige korrekte Gleichung", Evaluate(function="zeige_korrekte_gleichung"))],
	[Label("Fehlerart:"), TextField['Art'](25, 'font' = Font("arial",12), editable=false)],
	[Label("Fehlerhafter Ausdruck:"), TextField['Ausdruck'](25, 'font' = Font("arial",12), editable=false)],
	[Label("Korrekte Gleichung:"), TextField['korrekteGleichung'](25, 'font' = Font("arial",12), editable=false)]],
 
   hscroll=as_needed,vscroll=as_needed)
         
 ):


####################################################################################


FehlermapletSystem:= Maplet(BoxRow([

	[Label("Das System ist nicht korrekt!",'halign'=right, 'font' = Font("arial", bold, italic, 14))],
        [TextField['OhneAnzeige'](value="0", visible=false), TextField['MitAnzeige'](value="1", visible=false)],                                                                                                                                                                   
	[Button("OK", Shutdown()),Button("Hinweis: Falsche Gleichungen",
			Evaluate(function="fehlerhinweis_system"))],
	
	[Label("Fehlerhafte Gleichungen:"), TextField['Gleichungen'](40, 'font' = Font("arial",12), editable=false)]
	],
 
   hscroll=as_needed,vscroll=as_needed)
         
 ):



####################################################################################


FehlermapletVektor:= Maplet('onstartup'=Action(Evaluate(function="init_fehlermaplet"), RunWindow('W')),
	Window['W'](
		BoxRow([

		[Label("Folgende Koordinate ist nicht korrekt:",'halign'=right, 'font' = Font("arial", bold, italic, 14)),
		TextField['Koordinate'](width=5)],
        	[TextField['Artwert'](value="1", visible=false), TextField['Ausdruckwert'](value="2", visible=false)],                                                                                                                                                                    
		[Button("OK", Shutdown()),Button("Hinweis: Fehlerart",
			Evaluate(function="fehlerhinweis_vector",Argument('Artwert'))),
		Button("Hinweis: Fehlerhafter Ausdruck", 
			Evaluate(function="fehlerhinweis_vector",Argument('Ausdruckwert'))),
		Button("Zeige korrekte Koordinate", Evaluate(function="zeige_korrekte_vectorkoordinate"))],
		[Label("Fehlerart:"), TextField['Art'](25, 'font' = Font("arial",12), editable=false)],
		[Label("Fehlerhafter Ausdruck:"), TextField['Ausdruck'](25, 'font' = Font("arial",12), editable=false)],
		[Label("Korrekte Koordinate:"), TextField['korrekteKoordinate'](25, 'font' = Font("arial",12), editable=false)]],
 
   	hscroll=as_needed,vscroll=as_needed)
	)
         
 ):


####################################################################################


FehlermapletMatrix:= Maplet('onstartup'=Action(Evaluate(function="init_fehlermaplet_matrix"), RunWindow('W')),
	Window['W'](
		BoxRow([

		[Label("Folgende Matrixposition ist nicht korrekt:",'halign'=right, 'font' = Font("arial", bold, italic, 14)),
		TextField['Fehlerposition'](width=5)],
        	[TextField['Artwert'](value="1", visible=false), TextField['Ausdruckwert'](value="2", visible=false)],                                                                                                                                                                    
		[Button("OK", Shutdown()),Button("Hinweis: Fehlerart",
			Evaluate(function="fehlerhinweis_matrix",Argument('Artwert'))),
		Button("Hinweis: Fehlerhafter Ausdruck", 
			Evaluate(function="fehlerhinweis_matrix",Argument('Ausdruckwert'))),
		Button("Zeige korrekte Matrixposition", Evaluate(function="zeige_korrekte_matrixposition"))],
		[Label("Fehlerart:"), TextField['Art'](25, 'font' = Font("arial",12), editable=false)],
		[Label("Fehlerhafter Ausdruck:"), TextField['Ausdruck'](25, 'font' = Font("arial",12), editable=false)],
		[Label("Korrekter Matrixeintrag:"), TextField['korrekterMatrixeintrag'](25, 'font' = Font("arial",12), editable=false)]],
 
   	hscroll=as_needed,vscroll=as_needed)
	)
         
 ):



####################################################################################

FehlermapletAusdruck:= Maplet(BoxRow([

	[Label("Der Ausdruck ist nicht korrekt!",'halign'=right, 'font' = Font("arial", bold, italic, 14))],
        [TextField['Artwert'](value="1", visible=false), TextField['Ausdruckwert'](value="2", visible=false)],                                                                                                                                                                    
	[Button("OK", Shutdown()),Button("Hinweis: Fehlerart",
			Evaluate(function="fehlerhinweis_ausdruck",Argument('Artwert'))),
	Button("Hinweis: Fehlerhafter Ausdrucksteil", 
			Evaluate(function="fehlerhinweis_ausdruck",Argument('Ausdruckwert'))),
	Button("Zeige korrekten Ausdruck", Evaluate(function="zeige_korrekten_ausdruck"))],
	[Label("Fehlerart:"), TextField['Art'](25, 'font' = Font("arial",12), editable=false)],
	[Label("Fehlerhafter Ausdruck:"), TextField['Ausdruck'](25, 'font' = Font("arial",12), editable=false)],
	[Label("Korrekter Ausdruck:"), TextField['korrekterAusdruck'](25, 'font' = Font("arial",12), editable=false)]],
 
   hscroll=as_needed,vscroll=as_needed)
         
 ):


########################################################################################

FehlermapletFoeppl:= Maplet(BoxRow([

	[Label("Die Fpplfunktion ist nicht korrekt!",'halign'=right, 'font' = Font("arial", bold, italic, 14))],
                                                                                                                                                                            
        [TextField['Artwert'](value="1", visible=false), TextField['Ausdruckwert'](value="2", visible=false)],                                                                                                                                                                    
	[Button("OK", Shutdown()),Button("Hinweis: Fehlerart",
			Evaluate(function="fehlerhinweis_foeppl",Argument('Artwert'))),
	Button("Hinweis: FehlerhafterFunktionsteil", 
			Evaluate(function="fehlerhinweis_foeppl",Argument('Ausdruckwert'))),
	Button("Zeige korrekte Fpplfunktion", Evaluate(function="zeige_korrekten_foeppl"))],
	[Label("Fehlerart:"), TextBox['Art'](3..30, 'font' = Font("arial",12), editable=false)],
	[Label("Fehlerhafter Funktionsteil:"), TextBox['Ausdruck'](3..30, 'font' = Font("arial",12), editable=false)],
	[Label("Korrekte Fpplfunktion:"), TextBox['korrekteFoepplfunktion'](3..30, 'font' = Font("arial",12), editable=false)]],
 
   hscroll=as_needed,vscroll=as_needed)
         
 ):

####################################################################################


Systemloesungsmaplet:= Maplet('onstartup'= Action(Evaluate(function="init_systemloesung"), RunWindow('W')),
	
	Window['W'](BoxRow([

	[Label("Das System hat folgende Lsung",'halign'=right, 'font' = Font("arial", bold, italic, 14))],
	[TextBox['Loesung'](3..40, 'font' = Font("arial",12), editable=false)],
	Button("OK", Shutdown())
        
	],
 
   hscroll=as_needed,vscroll=as_needed))
         
 ):



#######################################################################################


loese_system:=proc(set_of_names,correct_systemname)
local result,find_ergebnis_LGS, find_ergebnis_VAR, system;
global aktuelles_system, aktuelles_korrektes_system, aktuelle_systemloesung, gl, i;

aktuelles_korrektes_system:=convert(correct_systemname,symbol);

for i from 1 to nops(set_of_names) do
gl:=set_of_names[i];
gleichung||i:=Maplets:-Tools:-Get( 'gl' );
od;
try aktuelles_system:={seq(eval(parse(gleichung||i)),i=1..nops(set_of_names))};
catch "incorrect syntax in parse":
	Maplets[Display](Syntaxfehlermaplet);
	return;
end try;


find_ergebnis_VAR:=find_name(aktuelles_korrektes_system, Variablen||__aufgabe);
if find_ergebnis_VAR[1]=1 then ERROR(`Finde Variablen-Menge fuer diese Aufgabe nicht`);
elif find_ergebnis_VAR[1]=2 then ERROR(`Finde Variablen-Namen fuer diese Aufgabe nicht`);
fi;

result:=solve(aktuelles_system, find_ergebnis_VAR[2]);

if result=NULL then aktuelle_systemloesung:=""; else 
aktuelle_systemloesung:=convert(result,string); 
fi;

Maplets[Display](Systemloesungsmaplet); 
 

end:

#######################################################################################

init_systemloesung:=proc()

Maplets:-Tools:-Set( 'Loesung' = aktuelle_systemloesung );

end:


#######################################################################################

init_fehlermaplet:=proc()

local cliste;

cliste:=["x","y","z"];

Maplets:-Tools:-Set( 'Koordinate' = aktuelle_falsche_koordinate );

end:


###################################################################################

zeige_loesung:=proc(loesungsdatei)

local systemstring:

# nutzt __aufgabe
# nutzt __acropfad

#systemstring:=cat(__acropfad, __aufgabe, ".pdf");

systemstring:=cat(__acropfad, "loesungen\\", convert(loesungsdatei,string));


system(systemstring);

end:


#######################################################################################


init_fehlermaplet_matrix:=proc()

Maplets:-Tools:-Set( 'Fehlerposition' = aktuelle_falsche_matrixposition );

end:



########################################################################################

#####		Umwandeln in MathML

umwandeln:=proc(inputfeldname,outputfeldname)

local inputexpression;

with(MathML):
try inputexpression:=parse(Maplets:-Tools:-Get( inputfeldname ));
catch "incorrect syntax in parse":
	Maplets[Display](Syntaxfehlermaplet);
	return;
end try;
Maplets:-Tools:-Set( outputfeldname=MathML[Export](inputexpression));

end:

########################################################################################

#####		Syntaxfehler-Maplet

Syntaxfehlermaplet:= Maplet('onstartup'= Action(RunWindow('W')),
	
	Window['W'](BoxRow(

	Label("Eingabefehler: Falsche Syntax (z.B. * vergessen oder Klammer vergessen)",\
			'font' = Font("arial", bold, italic, 14)),
	
	Button("OK", Shutdown()),
 
   hscroll=as_needed,vscroll=as_needed))
         
 ):



########################################################################################

######### 		Tool-Maplets

########################################################################################


foeppl_plot_maplet := Maplet(BoxRow([
 	[Label("Fppl-Funktionsplotter",'halign'=right, 'font' = Font("arial", bold, italic, 20))],   
	["Geben Sie eine Fppl-Funktion als Ausdruck in 'x' ein:"], 
	["Verwenden Sie die Notation {x-xi}^n, z.B. {x-2}^3"], 

	[TextField['TF2d']()],
	
	["Geben Sie auch den Plotbereich ein, z.B. x=0..5"],
	[TextField['Bereich']()],

	TextField['TFmath'](visible=false),  	TextField['InputName'](value="TF2d",visible=false),
	TextField['OutputName'](value="TFmath",visible=false), 

	GridLayout('border'=true,GridRow(GridCell(Plotter['PL1']( plot(undefined, x = 0..10,0..10,scaling=constrained))
						 )
					)
		  ),
    	[Button("Plot", Action(Evaluate(function="plot_foeppl", Argument('InputName'),Argument('OutputName')), 					
		Evaluate('PL1' = 'plot(TFmath, Bereich)')) ), 
	 Button("OK", Shutdown())]
 ], hscroll=as_needed,vscroll=as_needed)):

##########################################################################################

##########	Zeichenverfahrentool (Seileck, Krafteck, Culmann)

##########################################################################################

seileck_maplet := Maplet(BoxRow([
 	[Label("Seileck und Krafteck",'halign'=right, 'font' = Font("arial", bold, italic, 20))],   
	["Geben Sie eine Liste der Krfte ein in der Form  [ Kraft1, Kraft2, Kraft3, ..., Kraftn],"],
	["wobei eine Kraft in der Form [Angriffspunkt, Endpunkt], z.B. [[1,2],[3,-1]]"],
	["oder in der Form [Angriffspunkt, Betrag, Winkelgrad], z.B. [[1,2], 2, 30] anzugeben ist:"], 
	["Beispiel: [  [[1,2],[3,-1]] , [[1,2], 2, 30] ]."],
	["(Achtung: Der Anfangspunkt wird nur in der Seileckdarstellung verwendet!)"],
	[TextField['Kraefteliste']()],
	
	["Geben Sie optional noch einen Pol vor in der Form [2,3]"], 
	[TextField['Polangabe']()],

	TextField['plotstruktur'](visible=false),  TextField['Polfeldname'](value="Polangabe",visible=false),
	TextField['Plotstrukturname'](value="plotstruktur",visible=false), 
	TextField['ArtKraft'](value="Kraft",visible=false), TextField['ArtSeil'](value="Seil",visible=false),
	TextField['ArtBeides'](value="Beides",visible=false),

	GridLayout('border'=true,GridRow(GridCell(Plotter['PL1']( plot(undefined, x = 0..10,0..10,scaling=constrained))
						 )
					)
		  ),
    	[Button("Plot Krafteck", 
		Action(	Evaluate(function="seileck_plot", Argument('Kraefteliste'),Argument('ArtKraft'),
			Argument('Polfeldname'), Argument('Plotstrukturname')), 								Evaluate('PL1' = 'display('plotstruktur', scaling=CONSTRAINED)')) ), 
	 Button("Plot Seileck", 
		Action(	Evaluate(function="seileck_plot", Argument('Kraefteliste'),Argument('ArtSeil'),
			Argument('Polfeldname'), Argument('Plotstrukturname')), 								Evaluate('PL1' = 'display('plotstruktur', scaling=CONSTRAINED)')) ), 
	 Button("Plot Krafteck und Seileck", 
		Action(	Evaluate(function="seileck_plot", Argument('Kraefteliste'),Argument('ArtBeides'),
			Argument('Polfeldname'), Argument('Plotstrukturname')), 										Evaluate('PL1' = 'display('plotstruktur', scaling=CONSTRAINED)')) ), 
	 Button("OK", Shutdown())]
 ],hscroll=as_needed,vscroll=as_needed)):


##########################################################################################

culmann_maplet := Maplet(BoxRow([
 	[Label("Culmann-Gerade",'halign'=right, 'font' = Font("arial", bold, italic, 20))],   
	["Geben Sie eine Kraft in der Form "],
	["[Angriffspunkt, Richtungsvektor], z.B. [[1,2],[3,-1]], ein:"], [TextField['Kraft']()],
	["Geben Sie die drei Wirkungslinien in der Form [Ortsvektor, Richtungsvektor] ein, z.B. [[1,2],[3,-1]]"], 
	[Label("Gerade 1"),TextField['Gerade1']()],
	[Label("Gerade 2"),TextField['Gerade2']()],
	[Label("Gerade 3"),TextField['Gerade3']()],
	

	TextField['plotstruktur'](visible=false),  
	TextField['Plotstrukturname'](value="plotstruktur",visible=false), 

	GridLayout('border'=true,GridRow(GridCell(Plotter['PL1']( plot(undefined, x = 0..10,0..10,scaling=constrained))
						 )
					)
		  ),
    	[Button("Plot Culmann", 
		Action(	Evaluate(function="culmann_plot", Argument('Kraft'),Argument('Gerade1'),
			Argument('Gerade2'),Argument('Gerade3'), Argument('Plotstrukturname')), 											Evaluate('PL1' = 'display('plotstruktur', scaling=CONSTRAINED)')) ), 
	 Button("OK", Shutdown())]
 ],hscroll=as_needed,vscroll=as_needed)):


##########################################################################################



################################################################################################
################################################################################################

querschnitt_maplet:= Maplet(
	BoxRow('inset'=0,[[Label("Berechnung von Querschnittswerten fr Polygonzge",'halign'=center, 'font' = Font("arial", bold, italic, 20))],



		BoxLayout(BoxRow('border'=true,'inset'=0,(
			["Geben Sie einen geschlossenen Polygonzug in der folgenden Form ein:[Punkt1, Punkt2, Punkt3, ..., Punktn], wobei ein Punkt in der Form [x,y],",
			"also z.B. [1,2], einzugeben ist. Der erste Punkt muss gleich dem letzten sein. Beispiel: [[1,2],[2,3],[1.5,4],[1,4],[1,2]] .",
			"Die Punkte drfen auch Symbole enthalten (z.B. [1,a]); der Plot funktioniert dann natrlich nicht mehr.",
			"Sie knnen ferner optional einen Punkt P angeben, so dass die Trgheitsmomente bezglich Parallelachsen durch P berechnet werden.",
			[Label("Polygonzug: "),TextField['Polygonzug'](40), Label("Punkt P als Achsenursprung: "),TextField['Pol'](5) ]]
			
			
		))),    


	GridLayout( 	'border'=true,
			GridRow(halign=left, 
				GridCell(Button("Berechne Flche", 
					Evaluate(function="berechne_flaeche_m",Argument('Polygonzug'),Argument('NA1')))), 
				GridCell("F = "), 
				GridCell(TextField['A1'](4, 'font' = Font("arial",12),'width' = 10)), 
				GridCell(""), 
				GridCell(""), 
				GridCell(""), 
				GridCell("")	
				),
	    
			GridRow(halign=left, 
				GridCell(Button("Berechne statische Momente",
					Evaluate(function="berechne_statische_momente_m",Argument('Polygonzug'),Argument('NA2'),Argument('NA3')))),
				GridCell("Sx = "), 
				GridCell(TextField['A2'](4, 'font' = Font("arial",12),'width' = 10)), 
				GridCell( "Sy = "),
				GridCell(TextField['A3'](4, 'font' = Font("arial",12),'width' = 10)),
				GridCell(""),
				GridCell("")  
				),

			GridRow(halign=left, 
				GridCell(Button("Berechne Schwerpunkt",
					Evaluate(function="berechne_schwerpunkt_m",Argument('Polygonzug'),Argument('NA4'),Argument('NA5')))),
				GridCell("xs = "), 
				GridCell(TextField['A4'](4, 'font' = Font("arial",12),'width' = 10)),
				GridCell("ys = "), 
				GridCell(TextField['A5'](4, 'font' = Font("arial",12),'width' = 10)) ,
				GridCell(""), 
				GridCell("") 
				),
			GridRow(halign=left,
				GridCell(Button("Berechne Trgheitsmomente",
					Evaluate(function="berechne_traegheitsmomente_m",Argument('Polygonzug'),Argument('NA6'),Argument('NA7'), 
					Argument('NA8'),Argument('NA16')))),
				GridCell("Ix = "),
				GridCell(TextField['A6'](4, 'font' = Font("arial",12),'width' = 10)),
				GridCell("Iy = "),
				GridCell(TextField['A7'](4, 'font' = Font("arial",12),'width' = 10)),
				GridCell("Ixy = "),
				GridCell(TextField['A8'](4, 'font' = Font("arial",12),'width' = 10))
			),
			GridRow(halign=left,
				GridCell(Button("Berechne Trgheitsmomente bzgl. Schwerpunkt",
					Evaluate(function="berechne_traegheitsmomente_m",Argument('Polygonzug'),Argument('NA6a'),Argument('NA7a'), 
					Argument('NA8a'),Argument('NA16a')))),
				GridCell("Ixs = "),
				GridCell(TextField['A6a'](4, 'font' = Font("arial",12),'width' = 10)),
				GridCell("Iys = "),
				GridCell(TextField['A7a'](4, 'font' = Font("arial",12),'width' = 10)),
				GridCell("Ixys = "),
				GridCell(TextField['A8a'](4, 'font' = Font("arial",12),'width' = 10))
			),
			GridRow(halign=left,
				GridCell(Button("Berechne Trgheitsmomente bzgl. P",
					Evaluate(function="berechne_traegheitsmomente_m",Argument('Polygonzug'),Argument('NA9'),Argument('NA10'), 
						Argument('NA11'),Argument('NA12')))),
				GridCell("Ixp =  "),
				GridCell(TextField['A9'](4, 'font' = Font("arial",12),'width' = 10) ),
				GridCell("Iyp =  "),
				GridCell(TextField['A10'](4, 'font' = Font("arial",12),'width' = 10) ),
				GridCell("Ixyp =  "),
				GridCell(TextField['A11'](4, 'font' = Font("arial",12),'width' = 10) )
			),
			GridRow(halign=left,
				GridCell(Button("Berechne Haupttrgheitsmomente",
					Evaluate(function="berechne_haupttraegheitsmomente_m",Argument('Polygonzug'),
					Argument('NA13'),Argument('NA14'))) ),
				GridCell("I1 =  "),
				GridCell(TextField['A13'](4, 'font' = Font("arial",12),'width' = 10)),
				GridCell("I2 =  "),
				GridCell(TextField['A14'](4, 'font' = Font("arial",12),'width' = 10) ),
				GridCell(""), 
				GridCell("") 
				),
			GridRow(halign=left,
				GridCell(Button("Berechne Winkel",Evaluate(function="berechne_winkel_m",
						Argument('Polygonzug'),Argument('NA15'))) ),
				GridCell("alpha =  "), 
				GridCell(TextField['A15'](4, 'font' = Font("arial",12),'width' = 10) ),
				GridCell(""), 
				GridCell(""), 
				GridCell(""), 
				GridCell("")	
			)


	  ), 


	BoxLayout(BoxColumn('border'=true,'inset'=0,'spacing'=0,(


	TextField['NA1'](value="A1",visible=false),  TextField['NA2'](value="A2",visible=false),TextField['NA3'](value="A3",visible=false),
	TextField['NA4'](value="A4",visible=false),TextField['NA5'](value="A5",visible=false),TextField['NA6'](value="A6",visible=false),
	TextField['NA7'](value="A7",visible=false),TextField['NA8'](value="A8",visible=false),TextField['NA6a'](value="A6a",visible=false),
	TextField['NA7a'](value="A7a",visible=false),TextField['NA8a'](value="A8a",visible=false),
	TextField['NA9'](value="A9",visible=false),
	TextField['NA10'](value="A10",visible=false),TextField['NA11'](value="A11",visible=false),TextField['NA12'](value="Pol",visible=false),
	TextField['NA13'](value="A13",visible=false),TextField['NA14'](value="A14",visible=false),TextField['NA15'](value="A15",visible=false),
	TextField['NA16'](value="A16",visible=false), TextField['A16'](value="",visible=false),
	TextField['NA16a'](value="A16a",visible=false), TextField['A16a'](value="s",visible=false),
	TextField['plotfeldnametraeg'](value="plotfeldtraeg",visible=false),TextField['plotfeldtraeg'](visible=false),
	TextField['plotfeldnamequer'](value="plotfeldquer",visible=false),TextField['plotfeldquer'](visible=false),
	TextField['xbereichname'](value="xbereich",visible=false),
	TextField['ybereichname'](value="ybereich",visible=false),

		[Button("Berechne alle Werte",Evaluate(function="berechne_querschnittswerte_m",Argument('Polygonzug'), 
			Argument('NA1'), Argument('NA2'), Argument('NA3'), Argument('NA4'), Argument('NA5'),
			Argument('NA6'), Argument('NA7'), Argument('NA8'), Argument('NA6a'), Argument('NA7a'), Argument('NA8a'),
			Argument('NA9'), Argument('NA10'),
			Argument('NA11'), Argument('NA12'), Argument('NA16'),  Argument('NA16a'),Argument('NA13'), Argument('NA14'), Argument('NA15'))),
		 Button("Zeichne Trgheitskreis",Action( Evaluate(function="zeichne_traegheitskreis_m",Argument('Polygonzug'), 
					Argument('plotfeldnametraeg')), 
						Evaluate('PL1' = 'display('plotfeldtraeg', scaling=CONSTRAINED)'))),
		 Button("Zeichne Querschnitt mit Achsen",Action( Evaluate(function="zeichne_querschnitt_m",Argument('Polygonzug'), 
					Argument('plotfeldnamequer'), Argument('xbereichname'),
					Argument('ybereichname')), 
						Evaluate('PL1' = 'display('plotfeldquer', scaling=CONSTRAINED)'))),
		 Label("Breite des Plots (z.B. 10):"), TextField['xbereich'](width=5), Label("Hhe des Plots (z.B. 10):"), 
						TextField['ybereich'](width=5)]
	))),


	GridLayout('border'=true,GridRow(GridCell(Plotter['PL1']( plot(undefined, x = 0..10,0..10,scaling=constrained))
						 )
					)
		  ),



	[Button("Ende", Shutdown())]

],hscroll=always,vscroll=as_needed)):