read "G_generic_procedures_expr.mpl";
read "G_generic_procedures_eq.mpl";

with(StringTools):

####################################################################################
####################################################################################
####################################################################################

#		Prozeduren zum Gleichungscheck

####################################################################################
####################################################################################

####################################################################################

check_gleichung:= proc(gl,system)

global aktuelle_gleichung, aktuelles_korrektes_system;
local find_ergebnis_LGS, find_ergebnis_VAR, check_result, system_name;

system_name:=convert(system,symbol);
aktuelles_korrektes_system:=system_name;
aktuelle_gleichung:=gl;

if hastype(gl,equation)=false 
   then Maplets[Display](Maplet(AlertDialog("Die Eingabe ist keine Gleichung!",
		'onapprove'=Shutdown("true"), 'oncancel'=Shutdown("FAIL") )));

else
  find_ergebnis_LGS:=find_name(system_name, LGS||__aufgabe);
  if find_ergebnis_LGS[1]=1 then ERROR(`Finde LGS-Menge fuer diese Aufgabe nicht`);
     elif find_ergebnis_LGS[1]=2 then ERROR(`Finde LGS-Namen fuer diese Aufgabe nicht`);
  fi;

  find_ergebnis_VAR:=find_name(system_name, Variablen||__aufgabe);
  if find_ergebnis_VAR[1]=1 then ERROR(`Finde Variablen-Menge fuer diese Aufgabe nicht`);
  elif find_ergebnis_VAR[1]=2 then ERROR(`Finde Variablen-Namen fuer diese Aufgabe nicht`);
  fi;

  if G_check_equation(gl,find_ergebnis_LGS[2],find_ergebnis_VAR[2])=0 
	then Maplets[Display](Maplet(MessageDialog( "Die Gleichung ist korrekt.", 'onapprove'=Shutdown() )));
	else Maplets[Display](FehlermapletGleichung); 
  fi; 
fi;

end:



#######################################################################################


fehlerhinweis_gleichung:=proc(hint_type)
local find_result, find_ergebnis_LGS, find_ergebnis_VAR, equation, correct_systemname;

equation:=aktuelle_gleichung;
correct_systemname:=aktuelles_korrektes_system;

find_ergebnis_LGS:=find_name(correct_systemname, LGS||__aufgabe);
if find_ergebnis_LGS[1]=1 then ERROR(`Finde LGS-Menge fuer diese Aufgabe nicht`);
elif find_ergebnis_LGS[1]=2 then ERROR(`Finde LGS-Namen fuer diese Aufgabe nicht`);
fi;

find_ergebnis_VAR:=find_name(correct_systemname, Variablen||__aufgabe);
if find_ergebnis_VAR[1]=1 then ERROR(`Finde Variablen-Menge fuer diese Aufgabe nicht`);
elif find_ergebnis_VAR[1]=2 then ERROR(`Finde Variablen-Namen fuer diese Aufgabe nicht`);
fi;


	find_result:=G_find_error(equation, find_ergebnis_LGS[2],find_ergebnis_VAR[2]);
	if find_result[1]=0 then Maplets:-Tools:-Set( 'Art' = "Die Gleichung ist korrekt." );
	elif find_result[1]=1 then Maplets:-Tools:-Set( 'Art' = "Der Fehler konnte nicht identifiziert werden." ); 
	elif find_result[1]=2 then Maplets:-Tools:-Set( 'Art' = "Verwendung falscher Variablen." );  
		if hint_type=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi; 
	elif find_result[1]=3 then Maplets:-Tools:-Set( 'Art' = "Fehlerart: Vorzeichenfehler." );
		if hint_type=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi;
	elif find_result[1]=4 then Maplets:-Tools:-Set( 'Art' = "Fehlerart: Falscher Faktor." ); 
		if hint_type=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi;
	elif find_result[1]=5 then Maplets:-Tools:-Set( 'Art' = "Fehlerart: Falsche(r) Term(e)." );  
		if hint_type=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi;
	elif find_result[1]=6 then Maplets:-Tools:-Set( 'Art' = "Fehlerart: Fehlende(r) Term(e)." );  
		if hint_type=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi;
	elif find_result[1]=7 then Maplets:-Tools:-Set( 'Art' = "Fehlerart: Zu viele Terme." );
		if hint_type=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi; 
	fi; 
end:

#######################################################################################

#######################################################################################

zeige_korrekte_gleichung:=proc()
local find_result, find_ergebnis_LGS, find_ergebnis_VAR;


find_ergebnis_LGS:=find_name(aktuelles_korrektes_system, LGS||__aufgabe);
if find_ergebnis_LGS[1]=1 then ERROR(`Finde LGS-Menge fuer diese Aufgabe nicht`);
elif find_ergebnis_LGS[1]=2 then ERROR(`Finde LGS-Namen fuer diese Aufgabe nicht`);
fi;

find_ergebnis_VAR:=find_name(aktuelles_korrektes_system, Variablen||__aufgabe);
if find_ergebnis_VAR[1]=1 then ERROR(`Finde Variablen-Menge fuer diese Aufgabe nicht`);
elif find_ergebnis_VAR[1]=2 then ERROR(`Finde Variablen-Namen fuer diese Aufgabe nicht`);
fi;


find_result:=G_find_error(aktuelle_gleichung, find_ergebnis_LGS[2],find_ergebnis_VAR[2]);
if find_result[1]=0 then Maplets:-Tools:-Set( 'korrekteGleichung' = "Die Gleichung ist korrekt." ); 
elif find_result[1]=1 then Maplets:-Tools:-Set( 'korrekteGleichung' = "Der Fehler konnte nicht identifiziert werden." );
elif find_result[1]=2 then Maplets:-Tools:-Set( 'korrekteGleichung' = "Bei Fehlerart 'falsche Symbole' kann keine korrekte Gleichung gefunden werden." );
else Maplets:-Tools:-Set( 'korrekteGleichung' = find_result[3] ); 
fi; 

end:

#######################################################################################


#######################################################################################

check_system:=proc(set_of_names,correct_systemname)

local result,find_ergebnis_LGS, find_ergebnis_VAR, system, i, gl;
global aktuelles_system, aktuelles_korrektes_system;

aktuelles_korrektes_system:=convert(correct_systemname,symbol);

for i from 1 to nops(set_of_names) do
gl:=set_of_names[i];
gleichung||i:=Maplets:-Tools:-Get( 'gl' );
od;
try aktuelles_system:={seq(eval(parse(gleichung||i)),i=1..nops(set_of_names))};
catch "incorrect syntax in parse":
	Maplets[Display](Syntaxfehlermaplet);
	return;
end try;

find_ergebnis_LGS:=find_name(aktuelles_korrektes_system, LGS||__aufgabe);
if find_ergebnis_LGS[1]=1 then ERROR(`Finde LGS-Menge fuer diese Aufgabe nicht`);
elif find_ergebnis_LGS[1]=2 then ERROR(`Finde LGS-Namen fuer diese Aufgabe nicht`);
fi;

find_ergebnis_VAR:=find_name(aktuelles_korrektes_system, Variablen||__aufgabe);
if find_ergebnis_VAR[1]=1 then ERROR(`Finde Variablen-Menge fuer diese Aufgabe nicht`);
elif find_ergebnis_VAR[1]=2 then ERROR(`Finde Variablen-Namen fuer diese Aufgabe nicht`);
fi;

result:=G_check_system(aktuelles_system, find_ergebnis_LGS[2], find_ergebnis_VAR[2]);

if result[1]=0 then Maplets[Display](Maplet(MessageDialog( "Das System ist korrekt.", 'onapprove'=Shutdown() ))); 
else 
Maplets[Display](FehlermapletSystem); 
fi: 

end:

#######################################################################################

fehlerhinweis_system:=proc()
local result,find_ergebnis_LGS, find_ergebnis_VAR, system;
global aktuelles_system, aktuelles_korrektes_system;


find_ergebnis_LGS:=find_name(aktuelles_korrektes_system, LGS||__aufgabe);
if find_ergebnis_LGS[1]=1 then ERROR(`Finde LGS-Menge fuer diese Aufgabe nicht`);
elif find_ergebnis_LGS[1]=2 then ERROR(`Finde LGS-Namen fuer diese Aufgabe nicht`);
fi;

find_ergebnis_VAR:=find_name(aktuelles_korrektes_system, Variablen||__aufgabe);
if find_ergebnis_VAR[1]=1 then ERROR(`Finde Variablen-Menge fuer diese Aufgabe nicht`);
elif find_ergebnis_VAR[1]=2 then ERROR(`Finde Variablen-Namen fuer diese Aufgabe nicht`);
fi;

result:=G_check_system(aktuelles_system, find_ergebnis_LGS[2], find_ergebnis_VAR[2]);

if result[1]=0 then Maplets[Display](Maplet(MessageDialog( "Die Gleichung ist korrekt.", 'onapprove'=Shutdown() ))); 
else 
    if result[2]<>{} then Maplets:-Tools:-Set( 'Gleichungen' = result[2] ); 
			else Maplets:-Tools:-Set( 'Gleichungen' = "Es fehlen Gleichung(en)." ); fi;
fi: 

end:



#######################################################################################

zeige_fehlende_gleichung:=proc(set_of_names,correct_systemname)
local result, find_ergebnis_LGS, find_ergebnis_VAR, gleichungsmenge, i, system_name, number, fehlend, gl,
	gleichung;

system_name:=convert(correct_systemname,symbol);
number:=nops(set_of_names);

find_ergebnis_LGS:=find_name(system_name, LGS||__aufgabe);
if find_ergebnis_LGS[1]=1 then ERROR(`Finde LGS-Menge fuer diese Aufgabe nicht`);
elif find_ergebnis_LGS[1]=2 then ERROR(`Finde LGS-Namen fuer diese Aufgabe nicht`);
fi;

find_ergebnis_VAR:=find_name(system_name, Variablen||__aufgabe);
if find_ergebnis_VAR[1]=1 then ERROR(`Finde Variablen-Menge fuer diese Aufgabe nicht`);
elif find_ergebnis_VAR[1]=2 then ERROR(`Finde Variablen-Namen fuer diese Aufgabe nicht`);
fi;

gleichungsmenge:={};  fehlend:={};
for i from 1 to number do
gl:=set_of_names[i]:
gleichung:=Maplets:-Tools:-Get( 'gl' );
if length(gleichung)>0 then  
    try gleichungsmenge:=gleichungsmenge union {eval(parse(gleichung))};
    catch "incorrect syntax in parse":
	Maplets[Display](Syntaxfehlermaplet);
	return;
    end try; 
else fehlend:=fehlend union {set_of_names[i]}; fi;
od:


result:=G_provide_missing(gleichungsmenge, find_ergebnis_LGS[2],find_ergebnis_VAR[2], 
				nops(find_ergebnis_LGS[2])-nops(gleichungsmenge));


if result[1]=1 then Maplets[Display](Maplet(MessageDialog( "Das Eingabe-System enthaelt fehlerhafte Gleichungen.", 
							'onapprove'=Shutdown() )));
elif result[2]={} then Maplets[Display](Maplet(MessageDialog( "Es fehlt keine Gleichung.", 
							'onapprove'=Shutdown() )));
else
gl:=fehlend[1];
Maplets:-Tools:-Set( gl = result[2][1] );
fi; 

end:

#######################################################################################

zeige_korrektes_system:=proc(set_of_names, correct_systemname)
local find_ergebnis_LGS, system_name, i, gl;

system_name:=convert(correct_systemname,symbol);

find_ergebnis_LGS:=find_name(system_name, LGS||__aufgabe);
if find_ergebnis_LGS[1]=1 then ERROR(`Finde LGS-Menge fuer diese Aufgabe nicht`);
elif find_ergebnis_LGS[1]=2 then ERROR(`Finde LGS-Namen fuer diese Aufgabe nicht`);
fi;

for i from 1 to nops(find_ergebnis_LGS[2]) do
gl:=set_of_names[i];
Maplets:-Tools:-Set( gl = find_ergebnis_LGS[2][i] );
od;
 
end:

####################################################################################
####################################################################################
####################################################################################

#		Prozeduren zum Vektorcheck

####################################################################################
####################################################################################

####################################################################################

#######################################################################################


check_vector:=proc(xcoord,ycoord,zcoord, vector_name)
	local vect, find_ergebnis, check_result, i, fehler;
global aktueller_vector, aktueller_vector_name, aktuelle_falsche_koordinate, aktuelle_falsche_koordinate_wert;


	aktueller_vector_name:=vector_name;
	aktueller_vector:=[xcoord,ycoord,zcoord];
	find_ergebnis:=find_name(vector_name, Vektoren||__aufgabe);
	if find_ergebnis[1]=1 then ERROR(`Finde Vektormenge fuer diese Aufgabe nicht`);
	elif find_ergebnis[1]=2 then ERROR(`Finde Vektornamen fuer diese Aufgabe nicht`);
	else   fehler:=0;
		for i from 1 to 3 do
		check_result:=G_check_expression(aktueller_vector[i], evalm(find_ergebnis[2])[i]);
	     	if check_result=1  
		then    aktuelle_falsche_koordinate:=i:
			aktuelle_falsche_koordinate_wert:=aktueller_vector[i];
			Maplets[Display](FehlermapletVektor); 
		  	fehler:=1; break;
		fi;
		od;
	fi; 
	if fehler=0 then 
		Maplets[Display](Maplet(MessageDialog( "Der Vektor ist korrekt.", 'onapprove'=Shutdown() ))); 
	fi;
end:

#######################################################################################

fehlerhinweis_vector:=proc(hinweisart)

	local find_ergebnis, find_result;


	find_ergebnis:=find_name(aktueller_vector_name, Vektoren||__aufgabe);
	if find_ergebnis[1]=1 then ERROR(`Finde Vektorenmenge fuer diese Aufgabe nicht`);
	elif find_ergebnis[1]=2 then ERROR(`Finde Vektornamen fuer diese Aufgabe nicht`);
	fi;

	find_result:=G_find_error_expression(aktuelle_falsche_koordinate_wert, 
					evalm(find_ergebnis[2])[aktuelle_falsche_koordinate]);
	 
	if find_result[1]=1 then Maplets:-Tools:-Set( 'Art' = "Der Fehler konnte nicht identifiziert werden." ); 
	elif find_result[1]=2 then Maplets:-Tools:-Set( 'Art' = "Verwendung falscher Variablen." );  
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi; 
	elif find_result[1]=3 then Maplets:-Tools:-Set( 'Art' = "Fehlerart: Vorzeichenfehler." );
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi;
	elif find_result[1]=4 then Maplets:-Tools:-Set( 'Art' = "Fehlerart: Falscher Faktor." ); 
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi;
	elif find_result[1]=5 then Maplets:-Tools:-Set( 'Art' = "Fehlerart: Falsche(r) Term(e)." );  
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi;
	elif find_result[1]=6 then Maplets:-Tools:-Set( 'Art' = "Fehlerart: Fehlende(r) Term(e)." );  
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi;
	elif find_result[1]=7 then Maplets:-Tools:-Set( 'Art' = "Fehlende Variablen/Symbole." );
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi; 
	elif find_result[1]=8 then Maplets:-Tools:-Set( 'Art' = 
						"Falscher Operationstyp (z.B. Summe statt Produkt)." );
		if hint_type=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi; 
	else Maplets:-Tools:-Set( 'Art' = "Die Koordinate ist korrekt." );
	fi;


end:


#######################################################################################

zeige_korrekte_vectorkoordinate:=proc()
local find_ergebnis;

	find_ergebnis:=find_name(aktueller_vector_name, Vektoren||__aufgabe);
	if find_ergebnis[1]=1 then ERROR(`Finde Vektorenmenge fuer diese Aufgabe nicht`);
	elif find_ergebnis[1]=2 then ERROR(`Finde Vektorennamen fuer diese Aufgabe nicht`);
	else Maplets:-Tools:-Set( 'korrekteKoordinate' = evalm(find_ergebnis[2])[aktuelle_falsche_koordinate] );
	fi; 
	
	


end:



##############################################################################################
##############################################################################################
####################################################################################

#		Prozeduren zum Matrixcheck

####################################################################################
####################################################################################

####################################################################################


#######################################################################################


check_matrix:=proc(name,zeilenbezeichnung,spaltenbezeichnung)
	local eintragsmatrix, textfeld, eintrag,
		find_ergebnis, check_result, i, j, fehler;
	global aktuelle_matrix, aktueller_matrixname, aktuelle_falsche_matrixposition,
		 aktueller_falscher_matrixeintrag;
with(linalg):
aktueller_matrixname:=name;


eintragsmatrix:=array(1..nops(zeilenbezeichnung),1..nops(spaltenbezeichnung));



# Matrix aus Maplet holen

	for i from 1 to nops(zeilenbezeichnung) do
		for j from 1 to nops(spaltenbezeichnung) do

			textfeld:=cat(spaltenbezeichnung[j],zeilenbezeichnung[i]);
			eintrag:=Maplets:-Tools:-Get( 'textfeld' );
			if length(eintrag)>0 then 
				try eintragsmatrix[i,j]:=eval(parse(eintrag));
				catch "incorrect syntax in parse":
					Maplets[Display](Syntaxfehlermaplet);
					return;
				end try;
			else 	eintragsmatrix[i,j]:=0;
			fi;
			
		od;
	od;

	aktuelle_matrix:=eintragsmatrix;


	find_ergebnis:=find_name(name, Matrizen||__aufgabe);
	if find_ergebnis[1]=1 then ERROR(`Finde Matrizenmenge fuer diese Aufgabe nicht`);
	elif find_ergebnis[1]=2 then ERROR(`Finde Matrixnamen fuer diese Aufgabe nicht`);
	else    fehler:=0:
		for i from 1 to nops(zeilenbezeichnung) do
		  for j from 1 to nops(spaltenbezeichnung) do

		    check_result:=G_check_expression(eintragsmatrix[i,j], find_ergebnis[2][i,j]);
	     	    if check_result=1  
		      then 	aktuelle_falsche_matrixposition:=[i,j];
				aktueller_falscher_matrixeintrag:=eintragsmatrix[i,j];
		      fehler:=1; break; fi;
		  od;
		  if fehler=1 then break; fi;
	        od;
	fi; 
	if fehler=0 then 
		Maplets[Display](Maplet(MessageDialog( "Die Matrix ist korrekt.", 'onapprove'=Shutdown() ))); 
	else
		Maplets[Display](FehlermapletMatrix);
		
	fi;
end:

#######################################################################################

fehlerhinweis_matrix:=proc(hinweisart)

	local find_ergebnis, find_error, i,j, fehler, find_result;

	find_ergebnis:=find_name(aktueller_matrixname, Matrizen||__aufgabe);
	if find_ergebnis[1]=1 then ERROR(`Finde Matrizenmenge fuer diese Aufgabe nicht`);
	elif find_ergebnis[1]=2 then ERROR(`Finde Matrixnamen fuer diese Aufgabe nicht`);
	fi;

	fehler:=0;

	find_result:=G_find_error_expression(aktueller_falscher_matrixeintrag, 
					evalm(find_ergebnis[2])[aktuelle_falsche_matrixposition[1],
								aktuelle_falsche_matrixposition[2]]);
	 
	if find_result[1]=1 then Maplets:-Tools:-Set( 'Art' = "Der Fehler konnte nicht identifiziert werden." ); 
	elif find_result[1]=2 then Maplets:-Tools:-Set( 'Art' = "Verwendung falscher Variablen." );  
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi; 
	elif find_result[1]=3 then Maplets:-Tools:-Set( 'Art' = "Fehlerart: Vorzeichenfehler." );
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi;
	elif find_result[1]=4 then Maplets:-Tools:-Set( 'Art' = "Fehlerart: Falscher Faktor." ); 
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi;
	elif find_result[1]=5 then Maplets:-Tools:-Set( 'Art' = "Fehlerart: Falsche(r) Term(e)." );  
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi;
	elif find_result[1]=6 then Maplets:-Tools:-Set( 'Art' = "Fehlerart: Fehlende(r) Term(e)." );  
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi;
	elif find_result[1]=7 then Maplets:-Tools:-Set( 'Art' = "Fehlende Variablen/Symbole." );
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi; 
	elif find_result[1]=8 then Maplets:-Tools:-Set( 'Art' = 
						"Falscher Operationstyp (z.B. Summe statt Produkt)." );
		if hint_type=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi; 
	else Maplets:-Tools:-Set( 'Art' = "Die Matrixposition ist korrekt." );
	fi;
end:


#######################################################################################

zeige_korrekte_matrix:=proc(name, zeilenbezeichnung, spaltenbezeichnung)
local find_ergebnis, i, j, textfeld, korrekte_matrix;

	find_ergebnis:=find_name(name, Matrizen||__aufgabe);
	if find_ergebnis[1]=1 then ERROR(`Finde Matrizenmenge fuer diese Aufgabe nicht`);
	elif find_ergebnis[1]=2 then ERROR(`Finde Matrixnamen fuer diese Aufgabe nicht`);
	else korrekte_matrix:=find_ergebnis[2];
	fi; 


	for i from 1 to nops(zeilenbezeichnung) do
		for j from 1 to nops(spaltenbezeichnung) do

			textfeld:=cat(spaltenbezeichnung[j],zeilenbezeichnung[i]);
			Maplets:-Tools:-Set( textfeld=korrekte_matrix[i,j] );

			
		od;
	od;
	
end:


#######################################################################################

zeige_korrekte_matrixposition:=proc()
local find_ergebnis;

	find_ergebnis:=find_name(aktueller_matrixname, Matrizen||__aufgabe);
	if find_ergebnis[1]=1 then ERROR(`Finde Matrizenmenge fuer diese Aufgabe nicht`);
	elif find_ergebnis[1]=2 then ERROR(`Finde Matrixnamen fuer diese Aufgabe nicht`);
	else Maplets:-Tools:-Set( 'korrekterMatrixeintrag' = 		
				evalm(find_ergebnis[2])[aktuelle_falsche_matrixposition[1],
							aktuelle_falsche_matrixposition[2]]);
	fi; 
	
end:


#######################################################################################

loese_matrixgleichung:=proc(name, spaltenbezeichnung)
local find_ergebnis, i, j, textfeld, korrekte_matrix, rechte_seite, koeff_matrix, zeilenzahl, loesung,
			loesung_mit_name;
global aktuelle_systemloesung;

with(linalg):

	find_ergebnis:=find_name(name, Matrizen||__aufgabe);
	if find_ergebnis[1]=1 then ERROR(`Finde Matrizenmenge fuer diese Aufgabe nicht`);
	elif find_ergebnis[1]=2 then ERROR(`Finde Matrixnamen fuer diese Aufgabe nicht`);
	else korrekte_matrix:=find_ergebnis[2];
	fi; 

	zeilenzahl:=op(2,op(1,[op(2,eval(korrekte_matrix))]));

	koeff_matrix:=submatrix(korrekte_matrix, 1..zeilenzahl,1..(nops(spaltenbezeichnung)-1));
	rechte_seite:=subvector(korrekte_matrix, 1..zeilenzahl,nops(spaltenbezeichnung));
	loesung:=linsolve(koeff_matrix,rechte_seite);
	


if loesung=NULL then aktuelle_systemloesung:=""; 
else 
loesung_mit_name:=[seq(spaltenbezeichnung[i]=loesung[i],i=1..(nops(spaltenbezeichnung)-1))];
aktuelle_systemloesung:=convert(loesung_mit_name,string); 
fi;

Maplets[Display](Systemloesungsmaplet); 

	
end:


##############################################################################################
##############################################################################################
####################################################################################

#		Prozeduren zum Ausdruckscheck

####################################################################################
####################################################################################

####################################################################################
####################################################################
### Trigonometrische Ausdruecke fuer Gradmass statt Bogenmass

COS:=proc(Winkel) cos(convert(Winkel*degrees, radians)); end:
SIN:=proc(Winkel) sin(convert(Winkel*degrees, radians)); end:


#######################################################################################


check_ausdruck:=proc(ausdruck,name)
	local find_ergebnis, check_result;
	global aktueller_ausdruck, aktueller_ausdruckname;

	aktueller_ausdruckname:=name;
	aktueller_ausdruck:=ausdruck;

	find_ergebnis:=find_name(name, Ausdruecke||__aufgabe);
	if find_ergebnis[1]=1 then ERROR(`Finde Ausdruckmenge fuer diese Aufgabe nicht`);
	elif find_ergebnis[1]=2 then ERROR(`Finde Ausdrucknamen fuer diese Aufgabe nicht`);
	else check_result:=G_check_expression(ausdruck, find_ergebnis[2]);
	     if check_result=0  then 
		Maplets[Display](Maplet(MessageDialog( "Der Ausdruck ist korrekt.", 'onapprove'=Shutdown() )));
	     else Maplets[Display](FehlermapletAusdruck);
		
	     fi;
	fi; 
end:

#######################################################################################

fehlerhinweis_ausdruck:=proc(hinweisart)

	local find_ergebnis, find_result;

	find_ergebnis:=find_name(aktueller_ausdruckname, Ausdruecke||__aufgabe);
	if find_ergebnis[1]=1 then ERROR(`Finde Ausdruckmenge fuer diese Aufgabe nicht`);
	elif find_ergebnis[1]=2 then ERROR(`Finde Ausdrucknamen fuer diese Aufgabe nicht`);
	fi;

	find_result:=G_find_error_expression(aktueller_ausdruck, find_ergebnis[2]);

	if find_result[1]=1 then Maplets:-Tools:-Set( 'Art' = "Der Fehler konnte nicht identifiziert werden." ); 
	elif find_result[1]=2 then Maplets:-Tools:-Set( 'Art' = "Verwendung falscher Variablen." );  
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi; 
	elif find_result[1]=3 then Maplets:-Tools:-Set( 'Art' = "Fehlerart: Vorzeichenfehler." );
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi;
	elif find_result[1]=4 then Maplets:-Tools:-Set( 'Art' = "Fehlerart: Falscher Faktor." ); 
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi;
	elif find_result[1]=5 then Maplets:-Tools:-Set( 'Art' = "Fehlerart: Falsche(r) Term(e)." );  
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi;
	elif find_result[1]=6 then Maplets:-Tools:-Set( 'Art' = "Fehlerart: Fehlende(r) Term(e)." );  
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi;
	elif find_result[1]=7 then Maplets:-Tools:-Set( 'Art' = "Fehlende Variablen/Symbole." );
		if hinweisart=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi; 
	elif find_result[1]=8 then Maplets:-Tools:-Set( 'Art' = 
						"Falscher Operationstyp (z.B. Summe statt Produkt)." );
		if hint_type=2 then Maplets:-Tools:-Set( 'Ausdruck' = find_result[2] ); fi; 
	else Maplets:-Tools:-Set( 'Art' = "Der Ausdruck ist korrekt." );
	fi;

end:


#######################################################################################

zeige_korrekten_ausdruck:=proc()
local find_ergebnis;

	find_ergebnis:=find_name(aktueller_ausdruckname, Ausdruecke||__aufgabe);
	if find_ergebnis[1]=1 then ERROR(`Finde Ausdruckmenge fuer diese Aufgabe nicht`);
	elif find_ergebnis[1]=2 then ERROR(`Finde Ausdrucknamen fuer diese Aufgabe nicht`);
	else Maplets:-Tools:-Set( 'korrekterAusdruck' = find_ergebnis[2] ); 
	fi; 
	
end:

#######################################################################################
#######################################################################################
##############################################################################################
####################################################################################

#		Prozeduren zum Checken von Foepplfunktionen

####################################################################################
####################################################################################



hm:=z->Heaviside(z)*z:
h:=z->'hm(z)':


#============================================================================
#=====================  fetch_list_entry (foeppl)	             ========
#============================================================================


fetch_list_entry:=proc(foepplsummand)

local koeffizient, j, tableseq, mitfoeppl, hilfsliste;

koeffizient:=1;
tableseq:=NULL:
if op(0,foepplsummand)=hm then 
		tableseq:=tableseq,[op(1,foepplsummand),1,1];
elif op(0,foepplsummand)=`^` then
	     if op(0,op(1,foepplsummand))=hm then 
	       tableseq:=tableseq,[op(1,op(1,foepplsummand)),op(2,foepplsummand),1];
	     else  
	       tableseq:=tableseq,[1,1,foepplsummand];
	     fi;
elif whattype(foepplsummand)=`*` then
	     mitfoeppl:=false;
	     for j from 1 to nops(foepplsummand) do
	       if op(0,op(j,foepplsummand))=`^` then
		  if op(0,op(1,op(j,foepplsummand)))=hm then
		     mitfoeppl:=true;
		     hilfsliste[1]:=op(1,op(1,op(j,foepplsummand)));
		     hilfsliste[2]:=op(2,op(j,foepplsummand));
		  else koeffizient:=koeffizient*op(j,foepplsummand); 
		  fi;
	       elif op(0,op(j,foepplsummand))=hm then
		   mitfoeppl:=true;
		   hilfsliste[1]:=op(1,op(j,foepplsummand));
		   hilfsliste[2]:=1;
	       else koeffizient:= koeffizient*op(j,foepplsummand);
	       fi;
	     od;
	     if mitfoeppl=true then 
		  tableseq:=[hilfsliste[1],hilfsliste[2],koeffizient];
	     else tableseq:=[1,1,koeffizient];
	     fi;
else tableseq:=[1,1,foepplsummand];
     
fi;

RETURN(tableseq);
end:


#============================================================================
#=================  create table from foeppl expression  ========
#============================================================================


create_table:=proc(foepplexpr)

local tableseq,i;

tableseq:=NULL;

if whattype(foepplexpr)=`+` then
   for i from 1 to nops(foepplexpr) do
	tableseq:=tableseq,fetch_list_entry(op(i,foepplexpr));
   od;
else tableseq:=fetch_list_entry(foepplexpr);
fi;
RETURN([tableseq]);
end:



#============================================================================
#=====================  summarize foeppl list	                     ========
#============================================================================

summarize_foeppl:=proc(foeppl_list)

local i, j, k, newlist, flag;

newlist:=[op(1,foeppl_list)];

for i from 2 to nops(foeppl_list) do
    flag:=0:
    for j from 1 to nops(newlist) do
	if op(i,foeppl_list)[1]=newlist[j][1] and op(i,foeppl_list)[2]=newlist[j][2]
	   then newlist[j][3]:=newlist[j][3] + op(i,foeppl_list)[3];
	   flag:=1:
	fi;
    od;
    if flag=0 then 
	newlist:=[seq(newlist[k],k=1..nops(newlist)),op(i,foeppl_list)];
    fi;

od;
RETURN(newlist);
end:

#============================================================================
#=====================  compare summarized foeppl lists              ========
#============================================================================
#=== provides an error list

compare_foeppl:=proc(list1, correct_list)

local i, j, k, existing, WRONG_STARTING_POINT,WRONG_EXPONENT,
MISSING_STARTING_POINT,MISSING_EXPONENT,WRONG_COEFFICIENT,NOT_IDENTIFIED,
WRONG_SYMBOLS,SIGN_ERROR,WRONG_FACTORS,WRONG_TERMS,MISSING_TERMS,MISSING_SYMBOLS,
WRONG_TYPE, WRONG_OVERALL_PART, errorseq, start_point, expo, koeff, errorexpr;

# Definition of error types

WRONG_STARTING_POINT:=1:
WRONG_EXPONENT:=2:
MISSING_STARTING_POINT:=3:
MISSING_EXPONENT:=4:
WRONG_COEFFICIENT:=5:
WRONG_OVERALL_PART:=6:

# Special error types for wrong coefficient, taken from wrong expression

NOT_IDENTIFIED:=1:
WRONG_SYMBOLS:=2:
SIGN_ERROR:=3:
WRONG_FACTORS:=4:
WRONG_TERMS:=5:
MISSING_TERMS:=6:
MISSING_SYMBOLS:=7:
WRONG_TYPE:=8:

existing:=[seq([false,false], k=1..nops(correct_list))];
errorseq:=NULL:

for i from 1 to nops(list1) do
    start_point:=false; expo:=false; koeff:=false;
    for j from 1 to nops(correct_list) do
        if list1[i][1]=correct_list[j][1] then start_point:=true; existing[j][1]:=true:
	   if list1[i][2]=correct_list[j][2] then expo:=true; existing[j][2]:=true:
	      if simplify(list1[i][3]-correct_list[j][3])=0 then koeff:=true; fi;
	   fi;
	fi;
        if start_point=true and expo=true and koeff=true then break;
	elif start_point=true and expo=true and koeff=false then 
	     errorexpr:=G_find_error_expression(list1[i][3],correct_list[j][3]);
	     if list1[i][1]<>1 then
	     errorseq:=errorseq,[list1[i][1],list1[i][2],WRONG_COEFFICIENT, errorexpr];
	     else 
	     errorseq:=errorseq,[list1[i][1],list1[i][2],WRONG_OVERALL_PART, errorexpr];
	     fi:
	     break;
	fi;
	if j=nops(correct_list) then  
		if start_point=false then
		  errorseq:=errorseq,[list1[i][1],list1[i][2],WRONG_STARTING_POINT, []];
		elif expo=false then
		  errorseq:=errorseq,[list1[i][1],list1[i][2],WRONG_EXPONENT, []];
		fi;
	fi;
    od;
od;

for j from 1 to nops(correct_list) do
  if existing[j][1]=false then
	errorseq:=errorseq,[correct_list[j][1],correct_list[j][2],MISSING_STARTING_POINT, []];
  elif existing[j][1]=true and existing[j][2]=false then
	errorseq:=errorseq,[correct_list[j][1],correct_list[j][2],MISSING_EXPONENT, []];
  fi;
od;

RETURN([errorseq]);
end:


#============================================================================
#=================  check foeppl	  			     ========
#============================================================================
 
check_foeppl:=proc(name)
	local fstring, find_ergebnis, compare_result_ops;

	global aktueller_funktionsausdruck, aktueller_funktionsname;

	fstring:=Maplets:-Tools:-Get( 'name' );
	if length(fstring)=0 then ERROR(`Die Eingabe fehlt`); fi;

	with(StringTools):

	fstring:=SubstituteAll(fstring,"{","h(");
	fstring:=SubstituteAll(fstring,"}^0",")^_z");
	fstring:=SubstituteAll(fstring,"}",")");

	aktueller_funktionsname:=name;
	try aktueller_funktionsausdruck:=parse(fstring);
	catch "incorrect syntax in parse":
			Maplets[Display](Syntaxfehlermaplet);
			return;
	end try;


	find_ergebnis:=find_name(name(x), Foeppl||__aufgabe);
	if find_ergebnis[1]=1 then ERROR(`Finde Foepplmenge fuer diese Aufgabe nicht`);
	elif find_ergebnis[1]=2 then ERROR(`Finde Funktionsnamen fuer diese Aufgabe nicht`);
	fi;
	compare_result_ops:=nops(compare_foeppl(summarize_foeppl(create_table(aktueller_funktionsausdruck)),
				summarize_foeppl(create_table(find_ergebnis[2]))));
	if compare_result_ops=0
	     then Maplets[Display](Maplet(MessageDialog( "Die Funktion ist korrekt.", 'onapprove'=Shutdown() )));
	else 
		Maplets[Display](FehlermapletFoeppl);
	fi;

end:

#============================================================================
#=================  fehlerhinweis foeppl 			     ========
#============================================================================
 
fehlerhinweis_foeppl:=proc(hinweisart)
	local find_ergebnis, compare_result, fehlerartenmenge,i ,j, fehlerartstring, 
	exponent, fehlerausdruckstring,
	WRONG_STARTING_POINT,WRONG_EXPONENT, MISSING_STARTING_POINT,
	MISSING_EXPONENT,WRONG_COEFFICIENT, WRONG_OVERALL_PART;

# Definition of error types

WRONG_STARTING_POINT:=1:
WRONG_EXPONENT:=2:
MISSING_STARTING_POINT:=3:
MISSING_EXPONENT:=4:
WRONG_COEFFICIENT:=5:
WRONG_OVERALL_PART:=6:


find_ergebnis:=find_name(aktueller_funktionsname(x), Foeppl||__aufgabe);

if find_ergebnis[1]=1 then ERROR(`Finde Foepplmenge fuer diese Aufgabe nicht`);
elif find_ergebnis[1]=2 then ERROR(`Finde Funktionsnamen fuer diese Aufgabe nicht`);
fi;
	

compare_result:=compare_foeppl(summarize_foeppl(create_table(aktueller_funktionsausdruck)),
				summarize_foeppl(create_table(find_ergebnis[2])));
if nops(compare_result)=0
	     then Maplets:-Tools:-Set( 'Art' = "Die Funktion ist korrekt." );
fi;
	
#---- Fehlerarten sammeln und ausgeben


if hinweisart=1 then
   fehlerartenmenge:={}:
   for i from 1 to nops(compare_result) do
	    fehlerartenmenge:=fehlerartenmenge union {compare_result[i][3]}:
   od:
   fehlerartstring:="";
   for j in fehlerartenmenge do
	    if j=WRONG_STARTING_POINT then 
		fehlerartstring:=cat(fehlerartstring,"Ein oder mehrere Startpunkte sind falsch.\n");

	    elif j=WRONG_EXPONENT then 
		fehlerartstring:=cat(fehlerartstring,"Ein oder mehrere Exponenten sind falsch.\n");
	    elif j=MISSING_STARTING_POINT then 
		fehlerartstring:=cat(fehlerartstring,"Es fehlen ein oder mehrere Startpunkte.\n");
	    elif j=MISSING_EXPONENT then 
		fehlerartstring:=cat(fehlerartstring,"Es fehlen ein oder mehrere Exponenten.\n");
	    elif j=WRONG_COEFFICIENT then 
		fehlerartstring:=cat(fehlerartstring,"Ein oder mehrere Koeffizienten sind falsch.\n");
	    elif j=WRONG_OVERALL_PART then 
		fehlerartstring:=cat(fehlerartstring,"Der berall definierte Anteil ist falsch.\n");
	    fi;
   od;
   Maplets:-Tools:-Set( 'Art' = fehlerartstring ); 
else
   fehlerausdruckstring:="";
   for i from 1 to nops(compare_result) do

      if compare_result[i][3]=WRONG_STARTING_POINT 
	then fehlerausdruckstring:=cat(fehlerausdruckstring,"Falscher Startpunkt: ", 
					convert(compare_result[i][1],string), ".\n");
      elif compare_result[i][3]=WRONG_EXPONENT 
	then  if compare_result[i][2]=_z then exponent:="0" 
				else exponent:=convert(compare_result[i][2],string); fi;
	      fehlerausdruckstring:=cat(fehlerausdruckstring,"Falscher Exponent bei: ", 
					convert(compare_result[i][1],string), "und zwar:",
					exponent, ".\n");
      elif compare_result[i][3]=MISSING_STARTING_POINT 
	then fehlerausdruckstring:=cat(fehlerausdruckstring,"Fehlender Startpunkt: ", 
					convert(compare_result[i][1],string), ".\n");
      elif compare_result[i][3]=MISSING_EXPONENT
	then  if compare_result[i][2]=_z then exponent:="0" 
				else exponent:=convert(compare_result[i][2],string); fi;
	      fehlerausdruckstring:=cat(fehlerausdruckstring,"Fehlender Exponent bei: ", 
					convert(compare_result[i][1],string), "und zwar:",
					exponent, ".\n");
      elif compare_result[i][3]=WRONG_COEFFICIENT
	then fehlerausdruckstring:=cat(fehlerausdruckstring,"Falscher Koeffizient bei: ", 
					convert({compare_result[i][1]}^(compare_result[i][2]),string),
					 ".\n Fehlerart:", text_fehler(compare_result[i][4][1]),
					convert(compare_result[i][4][2],string));
      elif compare_result[i][3]=WRONG_OVERALL_PART
	then fehlerausdruckstring:=cat(fehlerausdruckstring,"Falscher ueberall definierter Anteil:\ ", 
					"Fehlerart: ", text_fehler(compare_result[i][4][1] ),
					convert(compare_result[i][4][2],string), ".\n");
      fi;
   od;
   Maplets:-Tools:-Set( 'Ausdruck' = fehlerausdruckstring ); 
fi;

end:

#============================================================================
#=================  wandle Fehlernummer bei Ausdruck in Text um	     ========
#============================================================================

text_fehler:=proc(fehler_nr)

local NOT_IDENTIFIED, WRONG_SYMBOLS, SIGN_ERROR, WRONG_FACTORS,
WRONG_TERMS, MISSING_TERMS, MISSING_SYMBOLS, WRONG_TYPE:

NOT_IDENTIFIED:=1:
WRONG_SYMBOLS:=2:
SIGN_ERROR:=3:
WRONG_FACTORS:=4:
WRONG_TERMS:=5:
MISSING_TERMS:=6:
MISSING_SYMBOLS:=7:
WRONG_TYPE:=8:

if fehler_nr=NOT_IDENTIFIED then RETURN(`Fehler nicht naeher identifiziert`)
elif fehler_nr=WRONG_SYMBOLS then RETURN(`falsche Symbole/Variablen`)
elif fehler_nr=SIGN_ERROR then RETURN(`Vorzeichenfehler`)
elif fehler_nr=WRONG_FACTORS then RETURN(`falsche reelle Faktoren`)
elif fehler_nr=WRONG_TERMS then RETURN(`falsche Terme`)
elif fehler_nr=MISSING_TERMS then RETURN(`fehlende Terme`)
elif fehler_nr=MISSING_SYMBOLS then RETURN(`fehlende Symbole/Variablen`)
elif fehler_nr=WRONG_TYPE then RETURN(`falsche Operation im Ausdruck`)
fi;

end:

#============================================================================
#=================  zeige korrekten foeppl-Ausdruck		     ========
#============================================================================
	
zeige_korrekten_foeppl:=proc()
	local find_ergebnis, fstring;

	with(StringTools):

	find_ergebnis:=find_name(aktueller_funktionsname(x), Foeppl||__aufgabe);
	if find_ergebnis[1]=1 then ERROR(`Finde Foepplmenge fuer diese Aufgabe nicht`);
	elif find_ergebnis[1]=2 then ERROR(`Finde Funktionsnamen fuer diese Aufgabe nicht`);
	fi;
	
	fstring:=convert(find_ergebnis[2],string);
	fstring:=SubstituteAll(fstring,"hm(","{");
	fstring:=SubstituteAll(fstring,")^_z","}^0");
	fstring:=SubstituteAll(fstring,")","}");

	Maplets:-Tools:-Set( 'korrekteFoepplfunktion' = fstring ); 
	
end:


