####################################################################################
####################################################################################

######                      Prozeduren fuer Maplet-Tools

####################################################################################
####################################################################################

with(Maplets):with(Maplets[Elements]):
with(StringTools):


###################################################################################

##########	Prozedur fuer Foeppl-Funktionsplot

###################################################################################

plot_foeppl := proc(stringfeldname, zielfeldname)
  
local aufgabe,  blatt, aufgabenmaplet, folgea, folgeb, gesamtfolge, gesamtliste, stringfolge,
		funktionsstring, fstring, i ;  


	fstring:=Maplets:-Tools:-Get( stringfeldname );

	folgea:=SearchAll("{",fstring);
	folgeb:=SearchAll("}",fstring);

	gesamtfolge:=NULL:

	if nops([folgea,1])=1 then funktionsstring:=fstring;
	else 	if nops([folgea])=1 then gesamtfolge:=folgea,folgeb;
	     	else
			for i from 1 to nops([folgea]) do gesamtfolge:=gesamtfolge,folgea[i],folgeb[i]; od;
	     	fi;
	     	gesamtliste:=[0,gesamtfolge,length(fstring)+1];

	    	stringfolge:=NULL:
		for i from 1 to nops(gesamtliste)-1 do 
			if gesamtliste[i]+1<=gesamtliste[i+1]-1 then 											stringfolge:=stringfolge,substring(fstring,gesamtliste[i]+1..gesamtliste[i+1]-1); 
			fi; 
		od;

		if type(nops([stringfolge]),odd)=true and gesamtliste[2]=1 then stringfolge:=stringfolge,"";fi;

		funktionsstring:=NULL:
 		for i from 1 to (nops([stringfolge]))/2 do
 			if gesamtliste[2]<>1 then 												funktionsstring:=cat(funktionsstring,stringfolge[2*i-1],"Heaviside(",stringfolge[2*i],
					")*(", stringfolge[2*i], ")"); 
 			else funktionsstring:=cat(funktionsstring,"Heaviside(",stringfolge[2*i-1],")*(", 
				stringfolge[2*i-1], ")",stringfolge[2*i]); 
			fi; 
		od;
		if type(nops([stringfolge]),odd)=true 
			then funktionsstring:=cat(funktionsstring, stringfolge[nops([stringfolge])]); fi;
	fi;

	Maplets:-Tools:-Set( zielfeldname=funktionsstring);


end:





####################################################################################

#############	   Prozeduren zum Zeichnen (Seileck, Krafteck, Culmann)  ###########

####################################################################################


### Prozedur zur Berechnung und Zeichnung des Seilecks und des
### Kraftecks

seileck_plot:=proc(kliste, art, polfeldname, plotstrukturname)
local   Anzahl_Kraefte, i, j, kfolge, Pol, kraftliste, differenzenfolge,
  	dliste, summe_x, summe_y, vorzeichen, Anfang_Kraftpolygon, 
	Anfangspunktefolge, Anfangspunkteliste,s, zeichnung, sp,
	seilschnittp, resultierende, resultat, Ausgabe, opts, stringarray, polstring;
with(plottools): 
with(plots):
if hastype(kliste,list)=false then
ERROR(`Eingabe muss Liste mit linienfluechtigen Kraftvektoren sein`);
fi;

Anzahl_Kraefte:=nops(kliste);


polstring:=Maplets:-Tools:-Get( 'polfeldname' );

if length(polstring)>0 then 	try Pol:=parse(polstring);
				catch "incorrect syntax in parse":
					Maplets[Display](Syntaxfehlermaplet);
					return;
				end try;
else Pol:=[0,0];
fi;

# wandle Kraefteliste in reine Anfangs-Endpunktliste um

kfolge:=NULL:
for j from 1 to Anzahl_Kraefte do
  if nops(kliste[j])=2 then kfolge:=kfolge, kliste[j];
  elif nops(kliste[j])=3 then kfolge:=kfolge, [kliste[j][1],
			[kliste[j][1][1]+ kliste[j][2]*cos(Pi/180*kliste[j][3]) , 
			kliste[j][1][2]+ kliste[j][2]*sin(Pi/180*kliste[j][3])]]
  else ERROR(`Kraft`, j , `ist falsch!`);
  fi;
od:

kraftliste:=[kfolge]:

# Plotten der Originalkraefte fuer das Seileck

for i from 1 to nops(kraftliste) do
  plotkraft||i:=plottools[arrow](kraftliste[i][1],kraftliste[i][2],
		.05, .2, .1, color=green):
od:

differenzenfolge:=NULL:
for i from 1 to nops(kraftliste) do
  differenzenfolge:=differenzenfolge, (kraftliste[i][2] -kraftliste[i][1]):
  od:
dliste:=[differenzenfolge]:

# Plotten der Wirkungslinien
 
for i from 1 to nops(kraftliste) do
  plotline||i:=line(kraftliste[i][1]-differenzenfolge[i],
			kraftliste[i][2]+differenzenfolge[i],
			linestyle=4, color=blue);
od;

# Anfangspunkt fuer erste Kraft festlegen; soll in der Regel
# so liegen, dass der Default-Pol [0,0] geeignet ist. Der
# Pol kann aber auch entsprechend per Parameter geaendert werden.
# Lege Anfangspunkt so, dass die Summe der y-Koordinaten der Kraefte
# durch den Pol [0,0] halbiert wird. Verwende aehnliche Heuristik
# fuer x-Koordinate.

summe_y:=add(dliste[i][2],i=1..nops(dliste)):
summe_x:=add(abs(dliste[i][1]),i=1..nops(dliste)):
vorzeichen:=signum(-dliste[1][1]):
Anfang_Kraftpolygon:=[-.5*vorzeichen*summe_x,-0.5*summe_y]:

Anfangspunktefolge:=Anfang_Kraftpolygon:
s:=Anfang_Kraftpolygon:
for i from 1 to nops(dliste) do
  s:=s+dliste[i];
  Anfangspunktefolge:=Anfangspunktefolge,s;
od:
Anfangspunkteliste:=[Anfangspunktefolge]:



for i from 1 to nops(Anfangspunkteliste)-1 do
  plot||i:=plottools[arrow](Anfangspunkteliste[i],Anfangspunkteliste[i+1],
		.05, .2, .1, color=green):
od:

# Resultierende
resultierende:=Anfangspunkteliste[nops(Anfangspunkteliste)]-
		Anfangspunkteliste[1];
plot||0:=plottools[arrow](Anfangspunkteliste[1],Anfangspunkteliste[nops(Anfangspunkteliste)],
		.05, .2, .1, color=brown):

# Zeichne jetzt Polstrahlen

for i from 1 to nops(Anfangspunkteliste) do
  strahl||i:=line(Pol,Anfangspunkteliste[i],color=red): od;

# Ermittle und Zeichne Schnittpunkte Wirkungslinie<->Seilstrahlen
# im Seileck

seilschnittp:=array(1..nops(kraftliste));
seilschnittp[1]:=kraftliste[1][1]; # evtl -1/2*differenz spaeter
for i from 2 to nops(kraftliste) do
  sp:=geradenschnitt(kraftliste[i-1][1],Pol-Anfangspunkteliste[i],
  			kraftliste[i][1],dliste[i]);
  if sp=-1 or sp=0 then ERROR(`innere Seilstrahlen sind parallel, \
			waehlen Sie einen anderen Pol`);
  else seilschnittp[i]:=sp; fi;
od;


for i from 1 to nops(kraftliste)-1 do
  seilstr||i:=line(seilschnittp[i],seilschnittp[i+1]);
od;

# zeichne aeussere Seilstrahlen, deren Schnittpunkt und den
# resultierenden Kraftvektor

sp:=geradenschnitt(seilschnittp[1], Pol-Anfangspunkteliste[1],
		seilschnittp[nops(kraftliste)], 
		Pol-Anfangspunkteliste[nops(kraftliste)+1]);

if sp=0 or sp=-1 then resultat:=
			plottools[arrow](Pol,Anfangspunkteliste[1],
				.05, .2, .1, color=brown),
			plottools[arrow](Anfangspunkteliste[1],Pol,
				.05, .2, .1, color=brown);
else resultat:=plottools[arrow](sp-1/2*resultierende,
		sp+1/2*resultierende,.05, .2, .1, color=brown),
		line(seilschnittp[1],sp),
		line(sp,seilschnittp[nops(kraftliste)]);
fi;

# Erstellung des Zeichnungsoutputs

zeichnung:=array(1..2):

zeichnung[1]:=display([resultat,seq(plotkraft||i,i=1..nops(kraftliste)),
	 seq(plotline||i,i=1..nops(kraftliste)),
	 seq(seilstr||i,i=1..nops(kraftliste)-1)], scaling=CONSTRAINED):
zeichnung[2]:=display([seq(strahl||i,i=1..nops(Anfangspunkteliste)),
	 seq(plot||i,i=0..Anzahl_Kraefte)], scaling=CONSTRAINED):
if art=Kraft then
	Maplets:-Tools:-Set( plotstrukturname=zeichnung[2] );
elif art=Seil then
	Maplets:-Tools:-Set( plotstrukturname=zeichnung[1] );
else
	stringarray:=convert(evalm(zeichnung),string);
	Maplets:-Tools:-Set( plotstrukturname=stringarray);
fi:




end:


###############################################################

### Verteilung einer Kraft auf drei Wirkungslinien, Culmann-Gerade

culmann_plot:=proc(kraft, gerade1, gerade2, gerade3, plotstrukturname)

# kraft = Liste aus Ortsvektor (vom Angriffspunkt), Richtungsvektor
# gerade1 = 1. Wirkungslinie, Liste aus Ortsvektor, Richtungsvektor 
# gerade1 = 2. Wirkungslinie, Liste aus Ortsvektor, Richtungsvektor 
# gerade1 = 3. Wirkungslinie, Liste aus Ortsvektor, Richtungsvektor 
# Name des Feldes im Maplet, in dem die Plotstruktur zu speichern ist

local schnitt1, schnitt2, gl1, gl2, gl3, alpha, lambda, mu, \
      vec1, vec2, vec3, r1, r2, r3, plotline, kraftlinie, cul, i, \
	plotkraft1, plotkraft2, plotkraft3, plotkraft4, \
	plotline1, plotline2, plotline3, displaydaten;


with(plots):
with(plottools):

# schneide 1. und 2. Wirkungslinie bzw. 3. Wirkungslinie und Kraftlinie

schnitt1:=geradenschnitt(gerade1[1],gerade1[2],gerade2[1],gerade2[2]):
schnitt2:=geradenschnitt(gerade3[1],gerade3[2],kraft[1],kraft[2]):

# Gleichungssystem fuer Einzelkraefte aufstellen

gl1:=
evalm(lambda*gerade1[2])[1]+evalm(mu*gerade2[2])[1] + evalm(alpha*gerade3[2])[1]=
kraft[2][1];
gl2:=
evalm(lambda*gerade1[2])[2]+evalm(mu*gerade2[2])[2] + evalm(alpha*gerade3[2])[2]=
kraft[2][2];

vec1:=evalm(gerade1[1]-kraft[1]); r1:=evalm(lambda*gerade1[2]):
vec2:=evalm(gerade2[1]-kraft[1]); r2:=evalm(mu*gerade2[2]):
vec3:=evalm(gerade3[1]-kraft[1]); r3:=evalm(alpha*gerade3[2]):

gl3:=vec1[1]*r1[2]-vec1[2]*r1[1] + vec2[1]*r2[2]-vec2[2]*r2[1] +
vec3[1]*r3[2]-vec3[2]*r3[1]=0;

solve({gl1,gl2,gl3},{lambda,mu,alpha});
assign(%):

#  jetzt zeichnen

# Wirkungslinien

plotline1:=line(convert(gerade1[1]-gerade1[2],list),
		convert(gerade1[1] +2*gerade1[2],list),
			linestyle=4, color=blue);
plotline2:=line(convert(gerade2[1]-gerade2[2],list),
		convert(gerade2[1] +2*gerade2[2],list),
			linestyle=4, color=blue);
plotline3:=line(convert(gerade3[1]-gerade3[2],list),
		convert(gerade3[1] +2*gerade3[2],list),
			linestyle=4, color=blue);

kraftlinie:=line(schnitt2,
			convert(kraft[1]+2*kraft[2],list),
			linestyle=4, color=blue);

# Culmanngerade

cul:=line(schnitt1,schnitt2,linestyle=1, thickness=3,color=pink);


# Kraefte

plotkraft1:=plottools[arrow](gerade1[1],gerade1[1]+lambda*gerade1[2],
		.05, .2, .1, color=green):
plotkraft2:=plottools[arrow](gerade2[1],gerade2[1]+mu*gerade2[2],
		.05, .2, .1, color=green):
plotkraft3:=plottools[arrow](gerade3[1],gerade3[1]+alpha*gerade3[2],
		.05, .2, .1, color=green):
plotkraft4:=plottools[arrow](kraft[1], kraft[1]+kraft[2],
		.05, .2, .1, color=red):

# Ausgabe

displaydaten:=display([plotkraft1, plotkraft2, plotkraft3, plotkraft4, plotline1, plotline2,plotline3, 
		kraftlinie, cul],scaling=constrained);

Maplets:-Tools:-Set( plotstrukturname=displaydaten);

end:

###############################################################

### Hilfsprozedur zum Schneiden vektorieller ebener Geraden
### Benoetigt: Ortsvektor 1, Richtungsvektor 1
###	       Ortsvektor 2, Richtungsvektor 2

geradenschnitt:=proc(g1p, g1r, g2p, g2r)
local loes, gls, schnitt, para1,para2; 

loes:=solve({g1p[1]+para1*g1r[1]=g2p[1]+para2*g2r[1], 
	g1p[2]+para1*g1r[2]=g2p[2]+para2*g2r[2]},{para1, para2}); 

if loes=NULL then RETURN(-1); fi;  # Parallelitaet

assign(loes); 

schnitt:=[eval(g1p[1]+para1*g1r[1]),eval(g1p[2]+para1*g1r[2])];

if type(schnitt[1],complex)=true and 
   type(schnitt[2],complex)=true
   then RETURN(schnitt);  # Schnittpunkt als Liste
   else RETURN(0)	; # Gleichheit der Geraden	
fi;
end:

###################################################################################

##########	Prozeduren fuer Querschnittswerte	(Aufruf durch Maplets)

###################################################################################


berechne_flaeche_m:=proc(polygonzug,zielfeld)

local flaeche;

if hastype(polygonzug,list)=false then
ERROR(`Eingabe muss Liste mit Punkten sein, also Liste von Paaren`);
fi;

flaeche:= evalf(berechne_flaeche(polygonzug),5);

Maplets:-Tools:-Set( zielfeld=flaeche);

end:

#================================================================================

berechne_statische_momente_m:=proc(polygonzug, zielfeld1, zielfeld2)

local ergebnis;

if hastype(polygonzug,list)=false then
ERROR(`Eingabe muss Liste mit Punkten sein, also Liste von Paaren`);
fi;


ergebnis:=evalf([berechne_statische_momente(polygonzug)],5);

Maplets:-Tools:-Set( zielfeld1=op(1,ergebnis));
Maplets:-Tools:-Set( zielfeld2=op(2,ergebnis));

end:

#=========================================================================


berechne_schwerpunkt_m:=proc(polygonzug, zielfeld1, zielfeld2) 
local ergebnis;


if hastype(polygonzug,list)=false then
ERROR(`Eingabe muss Liste mit Punkten sein, also Liste von Paaren`);
fi;

ergebnis:=evalf([berechne_schwerpunkt(polygonzug)],5);

Maplets:-Tools:-Set( zielfeld1=op(1,ergebnis));
Maplets:-Tools:-Set( zielfeld2=op(2,ergebnis));

end:

#===============================================================================




     
berechne_traegheitsmomente_m:=proc(polygonzug, zielfeld1, zielfeld2, zielfeld3, punktname)

local punkt,  momente;

if hastype(polygonzug,list)=false then
ERROR(`Eingabe muss Liste mit Punkten sein, also Liste von Paaren`);
fi;


punkt:=Maplets:-Tools:-Get( punktname);

if length(punkt)=0 then

	momente:=evalf([berechne_traegheitsmomente(polygonzug)],5);

	Maplets:-Tools:-Set( zielfeld1=momente[1]);
	Maplets:-Tools:-Set( zielfeld2=momente[2]);
	Maplets:-Tools:-Set( zielfeld3=momente[3]);

elif punkt="s" then
	momente:=evalf([berechne_traegheitsmomente(polygonzug)],5);

	Maplets:-Tools:-Set( zielfeld1=momente[4]);
	Maplets:-Tools:-Set( zielfeld2=momente[5]);
	Maplets:-Tools:-Set( zielfeld3=momente[6]);

else
	try momente:=evalf([berechne_traegheitsmomente(polygonzug,parse(punkt))],5);
	catch "incorrect syntax in parse":
		Maplets[Display](Syntaxfehlermaplet);
		return;
	end try;
	Maplets:-Tools:-Set( zielfeld1=momente[1]);
	Maplets:-Tools:-Set( zielfeld2=momente[2]);
	Maplets:-Tools:-Set( zielfeld3=momente[3]);

fi;


end:

#==========================================================================================

berechne_haupttraegheitsmomente_m:=proc(polygonzug, zielfeld1, zielfeld2)

local momente; # Traegheitsmomente


if hastype(polygonzug,list)=false then
ERROR(`Eingabe muss Liste mit Punkten sein, also Liste von Paaren`);
fi;

momente:=evalf([berechne_haupttraegheitsmomente(polygonzug)],5);

Maplets:-Tools:-Set( zielfeld1=momente[1]);
Maplets:-Tools:-Set( zielfeld2=momente[2]);

end:

#==================================================================================

berechne_winkel_m:=proc(polygonzug, zielfeld)

local winkel;

if hastype(polygonzug,list)=false then
ERROR(`Eingabe muss Liste mit Punkten sein, also Liste von Paaren`);
fi;

winkel:=evalf(berechne_winkel(polygonzug),5);
Maplets:-Tools:-Set( zielfeld=winkel);

end:

####----------------------------------------------------------------------------------------

berechne_querschnittswerte_m:=proc(polygonzug, zielfeld_F, zielfeld_Sx, zielfeld_Sy, zielfeld_xs, zielfeld_ys,
		zielfeld_Ix, zielfeld_Iy,
		zielfeld_Ixy, zielfeld_Ixs, zielfeld_Iys, zielfeld_Ixys,
		zielfeld_Ixp, zielfeld_Iyp, zielfeld_Ixyp, polfeldname,
		polfeldnameleer, polfeldnames, zielfeld_I1, zielfeld_I2, zielfeld_phi)


berechne_flaeche_m(polygonzug, zielfeld_F);
berechne_statische_momente_m(polygonzug,zielfeld_Sx, zielfeld_Sy);
berechne_schwerpunkt_m(polygonzug,zielfeld_xs, zielfeld_ys);
berechne_traegheitsmomente_m(polygonzug, zielfeld_Ix, zielfeld_Iy, zielfeld_Ixy, polfeldnameleer);
berechne_traegheitsmomente_m(polygonzug, zielfeld_Ixs, zielfeld_Iys, zielfeld_Ixys, polfeldnames);
berechne_traegheitsmomente_m(polygonzug, zielfeld_Ixp, zielfeld_Iyp, zielfeld_Ixyp, polfeldname);
berechne_haupttraegheitsmomente_m(polygonzug, zielfeld_I1, zielfeld_I2);
berechne_winkel_m(polygonzug, zielfeld_phi);

end:

#==========================================================================

zeichne_traegheitskreis_m:=proc(polygonzug, zielfeldplot_traeg)

local bild;


bild:=zeichne_traegheitskreis(polygonzug);

Maplets:-Tools:-Set( zielfeldplot_traeg=bild);

end:

#==========================================================================
zeichne_querschnitt_m:=proc(polygonzug,zielfeldplot_quer,xweitename, yweitename)

local bild, xbereich, ybereich;

xbereich:=Maplets:-Tools:-Get( xweitename );

ybereich:=Maplets:-Tools:-Get( yweitename );

if length(xbereich)>0 and length(ybereich)>0 then
	try bild:=zeichne_querschnitt(polygonzug, parse(xbereich)/2,parse(ybereich)/2);
	catch "incorrect syntax in parse":
		Maplets[Display](Syntaxfehlermaplet);
		return;
	end try;
else
	bild:=zeichne_querschnitt(polygonzug);
fi;

Maplets:-Tools:-Set( zielfeldplot_quer=bild);

end:




###############################################################################################
####################	 Interne Prozeduren fuer Querschnittswerte 
###############################################################################################

berechne_flaeche:=proc(polygonzug)

local i, Anzahl_Punkte;

if hastype(polygonzug,list)=false then
ERROR(`Eingabe muss Liste mit Punkten sein, also Liste von Paaren`);
fi;

Anzahl_Punkte:=nops(polygonzug)-1;


 1/2*add( polygonzug[i+1,2]*polygonzug[i,1]
      - polygonzug[i+1,1]*polygonzug[i,2],i=1..Anzahl_Punkte);


end:

#================================================================================

berechne_statische_momente:=proc(polygonzug, punkt)

local Sx,Sy, # statische Momente
      i, Anzahl_Punkte,
      A; # Flaeche;

if hastype(polygonzug,list)=false then
ERROR(`Eingabe muss Liste mit Punkten sein, also Liste von Paaren`);
fi;

Anzahl_Punkte:=nops(polygonzug)-1;



Sx:=1/6*add( (polygonzug[i,2] + polygonzug[i+1,2]) * 
		(polygonzug[i+1,2]* polygonzug[i,1]
		  - polygonzug[i,2]*polygonzug[i+1,1]), 
		i=1..Anzahl_Punkte);

Sy:=1/6*add( (polygonzug[i,1] + polygonzug[i+1,1]) * 
		(polygonzug[i+1,2] * polygonzug[i,1]
		  - polygonzug[i,2]*polygonzug[i+1,1]), 
		i=1..Anzahl_Punkte);
if nargs = 2 then

A:= berechne_flaeche(polygonzug);

Sx:=Sx - punkt[2]*A;
Sy:=Sy - punkt[1]*A;

fi;

Sx,Sy;

end:

#=========================================================================


berechne_schwerpunkt:=proc(polygonzug) 
local xs,ys, # Koordinaten des Schwerpunkts
      A,     # Flaeche
      Sx,Sy; # statische Momente


if hastype(polygonzug,list)=false then
ERROR(`Eingabe muss Liste mit Punkten sein, also Liste von Paaren`);
fi;


A:= berechne_flaeche(polygonzug);

Sx:=op(1,[berechne_statische_momente(polygonzug)]);

Sy:=op(2,[berechne_statische_momente(polygonzug)]);

xs:=Sy/A;
ys:=Sx/A;

xs,ys;

end:

#===============================================================================




     
berechne_traegheitsmomente:=proc(polygonzug, punkt)

local Ix,Iy,Ixy,Ixs,Iys,Ixys,Ixp,Iyp,Ixyp, # Traegheitsmomente
      xs,ys,  # Schwerpunktskoordinaten
      i, Anzahl_Punkte,
      A; # Flaeche;

if hastype(polygonzug,list)=false then
ERROR(`Eingabe muss Liste mit Punkten sein, also Liste von Paaren`);
fi;

Anzahl_Punkte:=nops(polygonzug)-1;


Ix:=1/12*add( ((polygonzug[i+1,2])^2 + 
		(polygonzug[i,2] + polygonzug[i+1,2])*polygonzug[i,2])*
		(polygonzug[i+1,2]*polygonzug[i,1] -
		polygonzug[i,2]*polygonzug[i+1,1]), i=1..Anzahl_Punkte);

Iy:=1/12*add( ((polygonzug[i+1,1])^2 + 
		(polygonzug[i,1] + polygonzug[i+1,1])*polygonzug[i,1])*
		(polygonzug[i+1,2]*polygonzug[i,1] -
		polygonzug[i,2]*polygonzug[i+1,1]), i=1..Anzahl_Punkte);

Ixy:=-1/12*add( 1/2*(polygonzug[i+1,1])^2*(polygonzug[i,2])^2 -
		1/2*(polygonzug[i,1])^2*(polygonzug[i+1,2])^2 -
		(polygonzug[i+1,2]*polygonzug[i,1] -
		polygonzug[i,2]*polygonzug[i+1,1]) *
		(polygonzug[i,1]*polygonzug[i,2] +
		 polygonzug[i+1,1]*polygonzug[i+1,2]), i=1..Anzahl_Punkte);

A:= berechne_flaeche(polygonzug);

xs:=op(1,[berechne_schwerpunkt(polygonzug)]);
ys:=op(2,[berechne_schwerpunkt(polygonzug)]);

Ixs:=Ix-ys^2*A;
Iys:=Iy-xs^2*A;
Ixys:=Ixy - xs*ys*A;

if nargs = 1 then
RETURN(Ix,Iy,Ixy,Ixs,Iys,Ixys);

elif nargs = 2 then

Ixp:=Ixs+(ys-punkt[2])^2*A;
Iyp:=Iys+(xs-punkt[1])^2*A;
Ixyp:=Ixys - (ys-punkt[2])*(xs-punkt[1])*A;

RETURN(Ixp,Iyp,Ixyp);

fi;

end:

#==========================================================================================

berechne_haupttraegheitsmomente:=proc(polygonzug)

local Ixs,Iys,Ixys,I1,I2; # Traegheitsmomente


if hastype(polygonzug,list)=false then
ERROR(`Eingabe muss Liste mit Punkten sein, also Liste von Paaren`);
fi;


Ixs:=op(4,[berechne_traegheitsmomente(polygonzug)]);
Iys:=op(5,[berechne_traegheitsmomente(polygonzug)]);
Ixys:=op(6,[berechne_traegheitsmomente(polygonzug)]);

I1:= (Ixs+Iys)/2 + .5*sqrt((Ixs-Iys)^2 + 4*Ixys^2);
I2:= (Ixs+Iys)/2 - .5*sqrt((Ixs-Iys)^2 + 4*Ixys^2);

I1,I2;


end:

#==================================================================================

berechne_winkel:=proc(polygonzug)

local Ixs,Iys,Ixys,I1, # Traegheitsmomente
      phi;    # Winkel zwischen x-Achse und Hauptachse, falls 2*phi aus [-Pi/2,Pi/2]


if hastype(polygonzug,list)=false then
ERROR(`Eingabe muss Liste mit Punkten sein, also Liste von Paaren`);
fi;



Ixs:=op(4,[berechne_traegheitsmomente(polygonzug)]);
Iys:=op(5,[berechne_traegheitsmomente(polygonzug)]);
Ixys:=op(6,[berechne_traegheitsmomente(polygonzug)]);


I1:=op(1,[berechne_haupttraegheitsmomente(polygonzug)]);

if I1-Iys=0 then phi:=90;
else phi:=arctan(-Ixys/(I1-Iys))*180/Pi;
fi;

#if Ixs <> Iys then
#	phi:=arctan(-2*Ixys/(Ixs-Iys))/2  *180/Pi;
#elif Ixys = 0 then    phi:=0;
#else phi = 45;
#fi;

evalf(phi);


end:



berechne_querschnittswerte:=proc(polygonzug)

local Ix,Iy,Ixy,Ixs,Iys,Ixys,I1,I2, # Traegheitsmomente
      phi,    # Winkel zwischen x-Achse und Hauptachse, falls 2*phi aus [-Pi/2,Pi/2]
      Sx,Sy,  # statische Momente
      xs,ys,  # Schwerpunktskoordinaten
      A; # Flaeche

if hastype(polygonzug,list)=false then
ERROR(`Eingabe muss Liste mit Punkten sein, also Liste von Paaren`);
fi;


A:=berechne_flaeche(polygonzug);

Sx:=op(1,[berechne_statische_momente(polygonzug)]);

Sy:=op(2,[berechne_statische_momente(polygonzug)]);


Ix:=op(1,[berechne_traegheitsmomente(polygonzug)]);
Iy:=op(2,[berechne_traegheitsmomente(polygonzug)]);
Ixy:=op(3,[berechne_traegheitsmomente(polygonzug)]);

xs:=op(1,[berechne_schwerpunkt(polygonzug)]);
ys:=op(2,[berechne_schwerpunkt(polygonzug)]);


Ixs:=op(4,[berechne_traegheitsmomente(polygonzug)]);
Iys:=op(5,[berechne_traegheitsmomente(polygonzug)]);
Ixys:=op(6,[berechne_traegheitsmomente(polygonzug)]);

I1:= op(1,[berechne_haupttraegheitsmomente(polygonzug)]);
I2:= op(2,[berechne_haupttraegheitsmomente(polygonzug)]);

phi:= berechne_winkel(polygonzug);


print(`Querschnittswerte:`);
print(`Flaeche: A = `, A);
print(`Schwerpunktkoordinaten: `);
print(`xs = `,xs,` ys = `, ys);
print(`Statische Momente bezglich des Ausgangskoordinatensystems: `);
print(`Su = `, Sx, ` Sv = `, Sy);

print(`Traegheitsmomente bzgl. des Schwerpunktskoordinatensystem: `);
print(`Ix = `, Ixs, `Iy = `, Iys, `Ixy = `, Ixys); 
print(`Haupttraegheitsmomente: `);
print(`I1 = `, I1, `I2 = `, I2);
print(`Winkel zwischen der x-Achse und der Achse von I1 = Imax: `);
print(`phi = `,phi);
end:

#==========================================================================

zeichne_traegheitskreis:=proc(polygonzug)

local Ixs,Iys,Ixys,I1,I2, # Traegheitsmomente
      radius, mittelpunkt, # Kreisdaten
      plot1,plot2,plot3,plot4,plot5,plot6,plot7,plot8; # Plotstrukturen fuer Traegheitskreis

with(plots):

Ixs:=op(4,[berechne_traegheitsmomente(polygonzug)]);
Iys:=op(5,[berechne_traegheitsmomente(polygonzug)]);
Ixys:=op(6,[berechne_traegheitsmomente(polygonzug)]);

I1:= op(1,[berechne_haupttraegheitsmomente(polygonzug)]);
I2:= op(2,[berechne_haupttraegheitsmomente(polygonzug)]);

radius:= (I1-I2)/2;
mittelpunkt:=[(I1+I2)/2 , 0];

plot1:=plot([mittelpunkt[1] + t*(Iys-mittelpunkt[1]), mittelpunkt[2] + t*Ixys,t=-1..1]):
plot2:=plot([ mittelpunkt[1] + radius*cos(phi) , 
	      mittelpunkt[2] + radius*sin(phi), phi=0..2*Pi], 
	      title=`Traegheitskreis (Hauptachsen:blau)`, scaling=constrained):
plot3:=textplot([Ixs,-Ixys,`(Ix,-Ixy)`],align={ABOVE,RIGHT}):
plot4:=textplot([Iys,Ixys,`(Iy,Ixy)`],align={ABOVE,RIGHT}):
if Ixs = I2 then 
     plot5:=plot([I2 ,  t*(I1-I2)/2,t=0..1],color=blue):
else plot5:=plot([I2+ t*(Ixs-I2) ,  t*(-Ixys),t=0..(I1-I2)/sqrt((Ixs-I2)^2+Ixys^2)],color=blue):
fi;

if Ixs = I1 then 
     plot6:=plot([I1 ,  t*(I1-I2)/2,t=0..1],color=blue):
else plot6:=plot([I1 + t*(Ixs-I1) , t*(-Ixys),t=0..(I1-I2)/sqrt((I1-Ixs)^2+Ixys^2)],color=blue):
fi;

plot7:=textplot([I2,0,`Imin`],align={ABOVE,LEFT}):
plot8:=textplot([I1,0,`Imax`],align={ABOVE,RIGHT}):

display([plot1,plot2,plot3,plot4,plot5,plot6,plot7,plot8],tickmarks=[5,5],scaling=CONSTRAINED);
end:

#==========================================================================
zeichne_querschnitt:=proc(polygonzug,xweite,yweite)

local plot1,plot2,plot3,plot4,
      gerade1,gerade2,
      weite,hoehe,
      xs,ys,phi;

with(plots):

xs:=op(1,[berechne_schwerpunkt(polygonzug)]);
ys:=op(2,[berechne_schwerpunkt(polygonzug)]);
phi:=berechne_winkel(polygonzug);

if nargs=1 then weite:=3;hoehe:=3; # default-Wert
elif nargs=2 then weite:=xweite; hoehe:=3;
else weite:=xweite; hoehe:=yweite; fi;

plot1:=plot(polygonzug,color=red,thickness=2):

if abs(phi-90)<=10^(-7) or abs(phi+90)<=10^(-7) then
plot2:=plot([xs,ys+hoehe*t,t=-1..1]):
else
gerade1:=ys + tan(phi*Pi/180)*(x-xs);
plot2:=plot(gerade1,x=(xs-weite)..(xs+weite),y=(ys-hoehe)..(ys+hoehe),color=green,thickness=2):
 fi:

if abs(phi)<=10^(-7) or abs(phi-180)<=10^(-7) then
plot3:=plot([xs,ys+weite*t,t=-1..1]):
else
gerade2:=ys + tan((phi+90)*Pi/180)*(x-xs);
plot3:=plot(gerade2,x=(xs-weite)..(xs+weite),y=(ys-hoehe)..(ys+hoehe),color=blue,thickness=2);
fi:

display([plot1,plot2,plot3],title=`Querschnitt und Hauptachsen: Maximum: gruen, Minimum:blau`,scaling=CONSTRAINED);
end:





